function Geometry
{
	function Shape
	{
		return [
			method draw(dc)
			{  }
		];
	} 
	function Point
	{
		local derived_point = [
			@x{@set (method(x)
			{
				if (std::typeof(x) != std::TYPEOF_NUMBER)
					std::error("Error: invalid type " + std::typeof(x) + ", x is type of Number!"); 
				@x = x;
			})@get (method
			{
				return @x;
			})},
			@x : 0,
			@y{@set (method(y)
			{
				if (std::typeof(y) != std::TYPEOF_NUMBER)
					std::error("Error: invalid type " + std::typeof(y) + ", y is type of Number!"); 
				@y = y;
			})@get (method
			{
				return @y;
			})},
			@y : 0,
			method distance(point)
			{  },
			method setLocation(point)
			{  }
		]; 
		local base_geometry_shape = ((Geometry)())["Shape"](); 
		std::inherit(derived_point, base_geometry_shape); 
		return derived_point;
	} 
	function Line
	{
		local derived_line = [
			@point1{@set (method(point1)
			{
				@point1 = point1;
			})@get (method
			{
				return @point1;
			})},
			@point2{@set (method(point2)
			{
				@point2 = point2;
			})@get (method
			{
				return @point2;
			})},
			method contains
			{  },
			method distance(point)
			{  },
			method getBounds
			{  },
			method intersects(rect)
			{  },
			method intersectsLine(line)
			{  },
			method setLine(line)
			{  }
		]; 
		local base_geometry_shape = ((Geometry)())["Shape"](); 
		std::inherit(derived_line, base_geometry_shape); 
		return derived_line;
	} 
	function RectangleOutCode
	{
		const OUT_BOTTOM = 0; 
		const OUT_RIGHT = 1; 
		const OUT_TOP = 2; 
		const OUT_LEFT = 3; 
		return [
			{ "OUT_BOTTOM" : OUT_BOTTOM },
			{ "OUT_RIGHT" : OUT_RIGHT },
			{ "OUT_TOP" : OUT_TOP },
			{ "OUT_LEFT" : OUT_LEFT }
		];
	} 
	function Rectangle
	{
		local derived_rectangle = [
			@point1{@set (method(point1)
			{
				@point1 = point1;
			})@get (method
			{
				return @point1;
			})},
			@point2{@set (method(point2)
			{
				@point2 = point2;
			})@get (method
			{
				return @point2;
			})},
			method area
			{  },
			method containsPoint(point)
			{  },
			method containsRectangle(rect)
			{  },
			method createIntersection(rect)
			{  },
			method createUnion(rect)
			{  },
			method intersects(rect)
			{  },
			method intersectsLine(line)
			{  },
			method outcode(point)
			{  },
			method perimeter
			{  },
			method setRect(rect)
			{  }
		]; 
		local base_geometry_shape = ((Geometry)())["Shape"](); 
		std::inherit(derived_rectangle, base_geometry_shape); 
		return derived_rectangle;
	} 
	function Circle
	{
		local derived_circle = [
			@center{@set (method(center)
			{
				@center = center;
			})@get (method
			{
				return @center;
			})},
			@radius{@set (method(radius)
			{
				if (std::typeof(radius) != std::TYPEOF_NUMBER)
					std::error("Error: invalid type " + std::typeof(radius) + ", radius is type of Number!"); 
				@radius = radius;
			})@get (method
			{
				return @radius;
			})},
			@radius : 0,
			method area
			{
				return std::pi() * @radius * @radius;
			},
			method containsPoint(point)
			{  },
			method intersectsLine(line)
			{  },
			method setCircle(circle)
			{  }
		]; 
		local base_geometry_shape = ((Geometry)())["Shape"](); 
		std::inherit(derived_circle, base_geometry_shape); 
		return derived_circle;
	} 
	return [
		@Shape : Shape,
		@Point : Point,
		@Line : Line,
		@RectangleOutCode : RectangleOutCode,
		@Rectangle : Rectangle,
		@Circle : Circle
	];
} 
circle = Geometry().Circle(); 
circle.radius = 2; 
std::print("Circle area = ", circle.area(), "\n");