using #emfMapping;
using #Functions;
using #Decorator;

const nl = "\n";

/////////////////////////////////////////////////////////////

dllXML = nil;
function Initialize () { dllXML = std::dllimportdeltalib("../dbc/" + xml::DLL); }

function CleanUp () { std::dllunimportdeltalib(dllXML); }

///////////////////////////////////////////////////////////////

function ecore2astData (rootobj) {
	local FuncMap = emfMapping::ClassifiersMapping ();
	
	local ast = nil;
	local astchild = nil;
	
	local funcArgs = [ @funcMap : FuncMap, @xmlobj : rootobj ];
	
	// root of call decoders
	ast = Functions::ePackage (funcArgs, true);
	
	return ast;
}

function AstCodeGenerator (ecorepath) {
	//
	local ecoreobj = xml::load (ecorepath);
	//
	local ast = nil;
	
	if (not ecoreobj) {
		std::print("Failed to load ECORE file!", nl);
		std::print(xml::loadgeterror(), nl);
		return nil;
	}

	//TODO try {
	
	ast = ::ecore2astData (ecoreobj);
	Decorator::Singleton().decorateTopLevelCode(ast.ast, ecoreobj);
	//TODO trap
	
	return ast.ast;
}

/*
function main () {
	//
	::Initialize ();
	//
	::AstCodeGenerator("../tests/sample.ecore");
	
}

main ();
*/