
function local AstHolder () {
	if (not static asts)
		asts = [];
	return asts;
}

/**
 * Returns astmap of ast with id
 *
 **/
function AstsMap (id) {
	local astmap = AstHolder()[id];
	if (std::isnil(astmap))
		std::error("Error: ask to get ast that is not load in system!");
	
	return astmap;
}

function getnamefirststmtbodyfunction (funcast) {
	local bodyast = std::ast_get_child (funcast, 2);
	// go to first stmt
	for (i=0;i<6;++i)
		bodyast = std::ast_get_child (bodyast, 0);
	//
	bodyast = std::ast_get_children(bodyast);
	local expr = bodyast.front();
	expr = std::ast_get_child(expr, 0);
	//
	return std::ast_get_attribute (expr, "name");
}

function gettypefirststmtbodyfunction (funcast) {
	try {
		local bodyast = std::ast_get_child (funcast, 2);
		// go to first stmt
		for (i=0;i<6;++i)
			bodyast = std::ast_get_child (bodyast, 0);
		//
		bodyast = std::ast_get_children(bodyast);
		local expr = bodyast.back();
		expr = std::ast_get_child(std::ast_get_child(expr, 0), 0);
		expr = std::ast_get_child(expr, 1);
		//
		local type = std::ast_get_attribute (expr, "name");
		type = std::strtokenise(type, "_").front();
		return type;
	}
	trap e {
		return nil;
	}
}


function createAstMap (ast) {
	astmap = [];
	
	functions = std::list_new();
	//
	visitor = std::astvisitor_new();
	visitor.set_handler("Function", function(node, id, entering) { if (entering) functions.push_back(node); });
	ast.accept_preorder(visitor);

	foreach (func, functions) {
		local astfunction = std::ast_get_child(func, "name");
		// get funcname
		local funcname = std::ast_get_attribute(astfunction, "name");
		//
		try {
			local name = getnamefirststmtbodyfunction (func);
			local type = gettypefirststmtbodyfunction (func);
			//
			if (name) {
				astmap [name] = [];
				if (type)
					astmap [name].type = type;
				astmap [name].funcname	= funcname;
				astmap [name].funcast	= func;
			}
		}
		trap e {
			//NOT all widget function have "getnamefirststmtbodyfunction"
			// these functions no need map
		}
	}
	return astmap;
}


function loadAst (ast) {
	AstHolder()[ast.id] = ::createAstMap(ast);
}

function unloadAst (ast) {
	AstHolder()[ast.id] = nil;
}
