const nl = "\n"; 
function GenTrapMSG(funcname)
{
	return <<
		std::print("Warning: invalid call of Converter Lib function " + ~(funcname) + " !!", nl); 
		std::print("Details:", nl);
	>>;
} 
function local  GenCodeStmtsToAdd(funcinsert)
{
	return <<
		local guiastmap1 = Data::AstsMap(ast1.id); 
		local guiastmap2 = Data::AstsMap(ast2.id); 
		if (std::isnil(guiastmap1[widget1]) or std::isnil(guiastmap2[widget2]))
			std::error("Widget name as " + widget2 + " NOT IN GUIAST!"); 
		funcname = guiastmap2[widget2].funcname; 
		funcast = std::ast_copy(guiastmap2[widget2].funcast); 
		if (guiastmap2[widget2].type == "panel")
			if (std::callglobal("getparent_type", ast1, widget1) == "notebookpage")
				fixFuncPanelNB(funcast, widget2);
			else
				fixFuncPanel(funcast, widget2); 
		tmpast = <<
			~~(funcast); 
			~~(Utilities::expr_new(funcname))(guichildobj);
		>>; 
		local stmt1 = tmpast.get_child(0); 
		local addMap = Data::createAstMap(stmt1); 
		foreach (widget, std::tabindices(addMap))
			guiastmap1[widget] = addMap[widget]; 
		~(funcinsert)(stmt1, guiastmap1, widget1); 
		~(funcinsert)(tmpast.get_child(0), guiastmap1, widget1);
	>>;
} 
std::inline(GenCodeStmtsToAdd(<<insertStmtafterStmt>>)); 
std::inline(GenTrapMSG(<<"insert_after">>)); 
std::inline(GenCodeStmtsToAdd(<<insertStmtbeforeStmt>>)); 
std::inline(GenTrapMSG(<<"insert_before">>)); 
std::inline(GenTrapMSG(<<"remove">>)); 
std::inline(GenTrapMSG(<<"insert_child">>)); 
function GenParentCode(element)
{
	return <<
		guiastmap = Data::AstsMap(ast.id); 
		if (std::isnil(guiastmap[~(element)]))
			std::error("Widget name as " + ~(element) + " NOT IN GUIAST!"); 
		local node = guiastmap[~(element)].funcast; 
		for (i = 0; i < 3; ++i)
			node = std::ast_get_parent(node); 
		local node = std::ast_get_parent(std::ast_get_parent(node));
	>>;
} 
std::inline(GenParentCode(<<widget>>)); 
std::inline(GenParentCode(<<widget>>)); 
std::inline(GenParentCode(<<widget>>)); 
function GenStmtsChildCode(element)
{
	return <<
		guiastmap = Data::AstsMap(ast.id); 
		~(( element ? <<
			if (std::isnil(guiastmap[~(element)]))
				std::error("Widget name as " + ~(element) + " NOT IN GUIAST!");
		>> : nil )); 
		local node = guiastmap[widget].funcast; 
		local funcname = guiastmap[widget].funcname; 
		for (i = 0; i < 3; ++i)
			node = std::ast_get_parent(node); 
		stmts = std::ast_get_children(node);
	>>;
} 
std::inline(GenStmtsChildCode(<<index>>)); 
std::inline(GenStmtsChildCode(nil)); 
std::inline(GenStmtsChildCode(nil)); 
std::inline(GenStmtsChildCode(nil)); 
std::inline(GenTrapMSG(<<"add_methodcall">>)); 
function GenRemoveEditCode
{
	return <<
		guiastmap = Data::AstsMap(ast.id); 
		if (std::isnil(guiastmap[widget]))
			std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
		local node = guiastmap[widget].funcast; 
		local funcname = guiastmap[widget].funcname; 
		local stmts = std::ast_get_child(std::ast_get_child(node, 2), 0); 
		local callstmt = nil; 
		index = 0; 
		foreach (stmt, stmts.get_children())
			{
				local child = std::ast_get_child(stmt, 0); 
				try {
						for (i = 0; i < 5; ++i)
							child = std::ast_get_child(child, 0); 
						child = std::ast_get_child(child, 1); 
						child = std::ast_get_child(child, 0); 
						local items = std::ast_get_attribute(child, "items"); 
						if (items.front() == methodName)
							{
								callstmt = stmt; 
								break;
							}
					}
				trap e
					{
						continue;
					}
			}
	>>;
} 
std::inline(GenRemoveEditCode()); 
std::inline(GenTrapMSG(<<"remove_methodcall">>)); 
std::inline(GenRemoveEditCode()); 
std::inline(GenTrapMSG(<<"edit_methodcall">>));