using #Utilities; 
const nl = "\n"; 
const msg = "NOT SPPORTED WXWIDGET in delta wxwidgets:" + nl; 
menubarid = 0; 
function createMenuBar(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "menubar" + ::menubarid; 
	objectname = objectxrc["$Attributes"].name; 
	++::menubarid; 
	local menubarid = ::menubarid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "menubar" + menubarid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "menubar"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "menubar" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::menubar_construct();
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "menubar"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									methodname += std::strlower(child); 
									if (child == "help")
										methodname += "string"; 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									if (child == "label")
										{
											astchild.ast = <<~(objectid), ~(astchild.ast)>>;
										} 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createMenuBar" + " function in " + "Decoders/Bars.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						if (funcname != "wxMenu")
							{
								std::error("Error: Invalid object child for wxMenuBar in xrc file! Child called " + child + " does not supported!");
							} 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "menubar" + "_" + ::menubarid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "menubar"; 
	tmpast = <<guiobj["parent"]["setmenubar"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
menuid = 0; 
function createMenu(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "menu" + ::menuid; 
	objectname = objectxrc["$Attributes"].name; 
	++::menuid; 
	local menuid = ::menuid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "menu" + menuid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "menu"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "menu" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::menu_construct();
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "menu"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									methodname += std::strlower(child); 
									if (child == "help")
										methodname += "string"; 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									if (child == "label")
										{
											astchild.ast = <<~(objectid), ~(astchild.ast)>>;
										} 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createMenu" + " function in " + "Decoders/Bars.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						if (funcname != "wxMenu" and funcname != "wxMenuItem" and funcname != "separator")
							{
								std::error("Error: Invalid object child for wxMenu in xrc file! Child called " + child + " does not supported!");
							} 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "menu" + "_" + ::menuid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "menu"; 
	tmpast = <<guiobj["parent"][~(( (object.parentType == "wx_menu") ? "appendsubmenu" : "append" ))](~(Utilities::expr_new(objectname)), ~((Utilities["label"]([
			@xrcObj : objectxrc["label"]
		])).ast))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
menuitemid = 0; 
function createMenuItem(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "menuitem" + ::menuitemid; 
	objectname = objectxrc["$Attributes"].name; 
	++::menuitemid; 
	local menuitemid = ::menuitemid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "menuitem" + menuitemid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "menuitem"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "menuitem" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::menuitem_construct(guiobj.parent, wx::ID_ANY);
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "menuitem"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									methodname += std::strlower(child); 
									if (child == "label")
										methodname = "settext"; 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createMenuItem" + " function in " + "Decoders/Bars.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				try {
						name = objectxrc["object"][index]["$Attributes"]["class"]; 
						std::error("Error: " + "wxMenuItem" + " must not include object childs." + nl + "Child object named as " + name + "!" + nl);
					}
				trap e
					{
						std::error("Error: " + "wxMenuItem" + " must not include object childs." + nl + "Object tag in xrc is invalid!" + nl);
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "menuitem" + "_" + ::menuitemid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "menuitem"; 
	tmpast = <<guiobj["parent"]["append"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
toolbarid = 0; 
function createToolBar(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "toolbar" + ::toolbarid; 
	objectname = objectxrc["$Attributes"].name; 
	++::toolbarid; 
	local toolbarid = ::toolbarid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "toolbar" + toolbarid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "toolbar"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "toolbar" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::toolbar_construct(guiobj.window, ~("toolbar" + toolbarid));
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "toolbar"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "style")
										{
											methodname += "window";
										}
									else
										if (child != "margins")
											{
												methodname += "tool";
											} 
									methodname += std::strlower(child); 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createToolBar" + " function in " + "Decoders/Bars.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						if (funcname != "tool" and funcname != "separator")
							{
								std::error("Error: Invalid object child for wxToolBar in xrc file! Child called " + child + " does not supported!");
							} 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "toolbar" + "_" + ::toolbarid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "toolbar"; 
	tmpast = <<guiobj["parent"]["settoolbar"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil )); 
		~(Utilities::expr_new(objectname))["realize"]();
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
toolid = 0; 
function addTool(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "tool" + ::toolid; 
	objectname = objectxrc["$Attributes"].name; 
	++::toolid; 
	local toolid = ::toolid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "tool" + toolid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "tool"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "tool" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::toolbartoolbase_construct(nil, ~("tool" + toolid));
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "tool"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "bitmap")
										{
											methodname += "normalbitmap";
										}
									else
										if (child == "tooltip")
											{
												methodname += "shorthelp";
											}
										else
											{
												methodname += std::strlower(child);
											} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("addTool" + " function in " + "Decoders/Bars.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				try {
						name = objectxrc["object"][index]["$Attributes"]["class"]; 
						std::error("Error: " + "wxTool" + " must not include object childs." + nl + "Child object named as " + name + "!" + nl);
					}
				trap e
					{
						std::error("Error: " + "wxTool" + " must not include object childs." + nl + "Object tag in xrc is invalid!" + nl);
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "tool" + "_" + ::toolid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "tool"; 
	tmpast = <<guiobj["parent"]["addtool"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
statusbarid = 0; 
function createStatusBar(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "statusbar" + ::statusbarid; 
	objectname = objectxrc["$Attributes"].name; 
	++::statusbarid; 
	local statusbarid = ::statusbarid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "statusbar" + statusbarid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "statusbar"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "statusbar" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::frame_createstatusbar(guiobj.window);
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "statusbar"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "style")
										{
											methodname += "windowstyle";
										}
									else
										if (child == "fields")
											{
												methodname += "fieldscount";
											}
										else
											{
												std::error("Error: Invalid");
											} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createStatusBar" + " function in " + "Decoders/Bars.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				try {
						name = objectxrc["object"][index]["$Attributes"]["class"]; 
						std::error("Error: " + "wxStatusBar" + " must not include object childs." + nl + "Child object named as " + name + "!" + nl);
					}
				trap e
					{
						std::error("Error: " + "wxStatusBar" + " must not include object childs." + nl + "Object tag in xrc is invalid!" + nl);
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "statusbar" + "_" + ::statusbarid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "statusbar"; 
	tmpast = nil; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
separator = 0; 
function addSeparator(createobj)
{
	Utilities::tabincrease(); 
	objectsrc = ""; 
	objectast = nil; 
	createdObject = nil; 
	createdfuncname = "create_separator"; 
	methodname = "separator"; 
	wxname = ""; 
	if (createobj.parentType == #wx_menu)
		{
			wxname = "menu"; 
			methodname = "append" + methodname;
		}
	else
		if (createobj.parentType == #wx_toolbar)
			{
				wxname = "toolbar"; 
				methodname = "add" + methodname;
			}
		else
			{
				local errormsg = ::msg + "Add separator only for wxMenu and wxToolBar." + nl; 
				errormsg += "NOT for " + createobj.parentType + nl; 
				std::error(errormsg);
			} 
	createdfuncname += wxname + ::separator; 
	++::separator; 
	objectsrc = Utilities::tab() + wxname + "obj." + methodname + "();" + nl; 
	Utilities::tabdecrease(); 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "(" + wxname + "obj) {" + nl + objectsrc + nl + Utilities::tab() + "}" + nl; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(guiobj)
		{
			guiobj.parent[~(methodname)]();
		}>>; 
	createdObject = [
		@ast : objectast,
		@astMap : createobj.astMap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
}