using #Utilities;
&using #Utilities;
&using #MetaGen;

const nl = "\n";
const msg = "NOT SPPORTED WXWIDGET in delta wxwidgets: ";




////////////////////////////  NoteBook object  //////////////////////////////


/*
*  wxNoteBook - createNoteBook function decoder
*/

notebookid = 0;

&defsNoteBook = [
	@id				: <<::notebookid>>,
	@funcname		: <<createNoteBook>>,
	@type			: <<"notebook">>,
	@wxconstruct	: <<wx::notebook_construct(guiobj.window, ~~("notebook"+notebookid) )>>,
	@setguiwindow	: <<guichildobj.window = ~~( Utilities::expr_new(objectname) ); >>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<notebookid>>, <<"notebook">>)); >>,
	@fixChildObject	: << ~(MetaGen::GenerateChildObjectCode ()); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute (
				 (MetaGen::GenerateWindowMethodname()),	"createNoteBook", "Decoders/Containers.dsc" )
			);
		>>,
	@createfuncargs		: <<~~( Utilities::expr_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"]["setwindow"]( ~~( Utilities::expr_new(objectname) ) )>>
];

! (MetaGen::GenerateDecoderFunction(defsNoteBook));


nbpageid = 0;

function addNoteBookPage (nbpagebj) {
	local tmpast = nil;
	objectxrc	= nbpagebj.xrcObj;
	objectname	= objectxrc["$Attributes"].name;
	! (MetaGen::GenerateObjectName (<<nbpageid>>, <<"nbpage">>));
	funcmap	= nbpagebj.funcMap;
	astmap	= nbpagebj.astMap;
	local childobj = [
		@funcMap : nbpagebj.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : nbpagebj.registerWidgetFuncName
	];
	//////
	////  parentType is nil, wxpanel, wxwindow objects will not try
	////  setobject2parent in generated code
	// childobj.parentType = "wx_notebookpage";
	//////
	objectsrc = Utilities::tab() + "local " + objectname + " = [];"+nl;
	local objectast = <<
						local ~(Utilities::id_new(objectname)) = [];
	>>;
	//
	if (Utilities::hasObjectChild(objectxrc)) {
		objectsrc += "guiobj.parent = " + objectname + ";" + nl;
		objectast = <<
						~objectast;
						local guichildobj = [];
						guichildobj.parent = ~(Utilities::expr_new(objectname));
						guichildobj.window = guiobj.window;
		>>;
	}
	
	////  page
	
	local wxpagename = objectxrc["object"][0]["$Attributes"]["class"];
	childobj.parent = objectname;
	childobj.xrcObj = objectxrc["object"][0];
	childobj.parentType = "nbpage";
	
	astchild = funcmap [ wxpagename ] (childobj);
	objectast = <<
					~objectast;
					~(astchild.ast);
	>>;
	objectsrc += astchild.src + nl;
	//
	local varid = "";
	for(i=7;i<std::strlen(astchild.funcname);++i) {
		varid += std::strchar(astchild.funcname, i);
	}
	//
	objectsrc += Utilities::tab() + "local " + varid + " = " + astchild.funcname + "( " + objectname + " );" + nl;
	//
	callast   = <<
					~(Utilities::expr_new(astchild.funcname)) (guichildobj);
	>>;
	objectast  = <<
					~objectast;
					~callast;
	>>;
	objectsrc += objectname + "[0] = " + varid + ";" + nl;
	
	//// label
	
	if (objectxrc["label"] != nil) {
		childobj.xrcObj = objectxrc["label"];
		childast = Utilities::label (childobj);
		objectast = <<
					~objectast;
					~(Utilities::lvalue_new(objectname)) [1] = ~(childast.ast);
		>>;
		objectsrc += objectname + "[1] = " + childobj.src + ";" + nl;
	}
	else {
		objectast = <<
					~objectast;
					~(Utilities::lvalue_new(objectname)) [1] = "";
		>>;
		objectsrc += objectname + "[1] = \"\" ;" + nl;
	}
	
	//// selected
	
	if (objectxrc["selected"] != nil) {
		childobj.xrcObj = objectxrc["selected"];
		childast = Utilities::selected (childobj);
		objectast = <<
					~objectast;
					~(Utilities::lvalue_new(objectname)) [2] = ~((childast.src=="1"?true:false));
		>>;
		objectsrc += objectname + "[2] = " + (childobj.src=="1"?"true":"false") + ";" + nl;
	}
	else {
		objectast = <<
					~objectast;
					~(Utilities::lvalue_new(objectname)) [2] = false;
		>>;
		objectsrc += objectname + "[2] = false;" + nl;
	}
	
	//// set notebookpage object
	
	Utilities::tabdecrease();
	//
	createdfuncname = "create_nbpage_" + nbpageid;
	astmap[objectname]    = [];
	astmap[objectname][0] = createdfuncname;
	astmap[objectname][1] = "notebookpage";
	//
	objectast = <<
					function ~(Utilities::id_new(createdfuncname)) (guiobj) {
						~objectast;
						guiobj["parent"]["addpage"] (|~(Utilities::expr_new(objectname))|);
					}
	>>;
	objectsrc = Utilities::tab() + "function "+createdfuncname+"() {" + nl + objectsrc + Utilities::tab() + "}";
	createdObject =
	[
		@ast	: objectast,
		@astMap	: astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	];
	return createdObject;
}

/******************** AuiNoteBook not supperted in delta widgets ******************/


function createAuiNoteBook () { std::error( ::msg + "wxAuiNoteBook" ); }



//////////////////////////////////////////////////////////////////////////////////


/*
*  wxScrolledWindow - createScrolledWindow function decoder
*/

scrolledwindowid = 0;

&defsScrolledWindow = [
	@id				: <<::scrolledwindowid>>,
	@funcname		: <<createScrolledWindow>>,
	@type			: <<"scrolledwindow">>,
	@wxconstruct	: <<wx::scrolledwindow_construct(guiobj.window, ~~("scrolledwindow"+scrolledwindowid) )>>,
	@setguiwindow	: <<guichildobj.window = ~~( Utilities::expr_new(objectname) ); >>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<scrolledwindowid>>, <<"scrolledwindow">>)); >>,
	@fixChildObject	: << ~(MetaGen::GenerateChildObjectCode ()); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute (
				 (MetaGen::GenerateWindowMethodname()),	"createScrolledWindow", "Decoders/Containers.dsc" )
			);
		>>,
	@createfuncargs		: <<~~( Utilities::expr_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"]["setwindow"]( ~~( Utilities::expr_new(objectname) ) )>>
];

! (MetaGen::GenerateDecoderFunction(defsScrolledWindow));


/*
*  wxSplitterWindow - createSplitterWindow function decoder
*/

splitterwindowid = 0;

&defsSplitterWindow = [
	@id				: <<::splitterwindowid>>,
	@funcname		: <<createSplitterWindow>>,
	@type			: <<"splitterwindow">>,
	@wxconstruct	: <<wx::scrolledwindow_construct(guiobj.window, ~~("splitterwindow"+splitterwindowid) )>>,
	@setguiwindow	: <<guichildobj.window = ~~( Utilities::expr_new(objectname) ); >>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<splitterwindowid>>, <<"splitterwindow">>)); >>,
	@fixChildObject	: << ~(MetaGen::GenerateChildObjectCode ()); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute (
				 (MetaGen::GenerateWindowMethodname(
					 <<
						if (child == "orientation") {
							methodname = "setsplitmode";
							//change child name to call the specific utility
							child = "splitmode";
						}
						else
						if (child == "sashpos") {
							methodname += child + "ition";
						}
						else
						if (child == "gravity") {
							methodname += "sash" + child;
						}
						else
						if (child == "minsize") {
							methodname = "setminimumpanesize";
						}
						else
							~~code;
					 >>
				 )),
				 "createSplitterWindow",
				 "Decoders/Containers.dsc"
		)
			);
		>>,
	@createfuncargs		: <<~~( Utilities::expr_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"]["setwindow"]( ~~( Utilities::expr_new(objectname) ) )>>
];

! (MetaGen::GenerateDecoderFunction(defsSplitterWindow));




/////////////////////////////////////////////////////////////////////////



function createListBook () { std::error( ::msg + "wxListBook" ); }


function createChoiceBook () { std::error( ::msg + "wxChoiceBook" ); }


