using #Utilities; 
const nl = "\n"; 
const msg = "NOT SPPORTED WXWIDGET in delta wxwidgets: "; 
notebookid = 0; 
function createNoteBook(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "notebook" + ::notebookid; 
	objectname = objectxrc["$Attributes"].name; 
	++::notebookid; 
	local notebookid = ::notebookid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "notebook" + notebookid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "notebook"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "notebook" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::notebook_construct(guiobj.window, ~("notebook" + notebookid));
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "notebook"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "bg")
										{
											methodname += "backgroundcolour"; 
											child = "colour";
										}
									else
										if (child == "fg")
											{
												methodname += "foregroundcolour"; 
												child = "colour";
											}
										else
											if (child == "pos")
												{
													methodname = "move";
												}
											else
												if (child == "style")
													{
														methodname += "window" + child;
													}
												else
													if (child == "exstyle")
														{
															methodname += "extrastyle";
														}
													else
														if (child == "hidden")
															{
																methodname = "hide";
															}
														else
															if (child == "enabled")
																{
																	methodname = "enable";
																}
															else
																{
																	methodname += std::strlower(child);
																} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createNoteBook" + " function in " + "Decoders/Containers.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = <<
		guichildobj.window = ~(Utilities::expr_new(objectname));
	>>; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.window = ~(Utilities::expr_new(objectname)); 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = ~(Utilities::expr_new(objectname)); 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "notebook" + "_" + ::notebookid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "notebook"; 
	tmpast = <<guiobj["parent"]["setwindow"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::expr_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
nbpageid = 0; 
function addNoteBookPage(nbpagebj)
{
	local tmpast = nil; 
	objectxrc = nbpagebj.xrcObj; 
	objectname = objectxrc["$Attributes"].name; 
	++::nbpageid; 
	local nbpageid = ::nbpageid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "nbpage" + nbpageid;
		} 
	funcmap = nbpagebj.funcMap; 
	astmap = nbpagebj.astMap; 
	local childobj = [
		@funcMap : nbpagebj.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : nbpagebj.registerWidgetFuncName
	]; 
	objectsrc = Utilities::tab() + "local " + objectname + " = [];" + nl; 
	local objectast = <<
		local ~(Utilities::id_new(objectname)) = [];
	>>; 
	if (Utilities::hasObjectChild(objectxrc))
		{
			objectsrc += "guiobj.parent = " + objectname + ";" + nl; 
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname)); 
				guichildobj.window = guiobj.window;
			>>;
		} 
	local wxpagename = objectxrc["object"][0]["$Attributes"]["class"]; 
	childobj.parent = objectname; 
	childobj.xrcObj = objectxrc["object"][0]; 
	childobj.parentType = "nbpage"; 
	astchild = funcmap[wxpagename](childobj); 
	objectast = <<
		~(objectast); 
		~(astchild.ast);
	>>; 
	objectsrc += astchild.src + nl; 
	local varid = ""; 
	for (i = 7; i < std::strlen(astchild.funcname); ++i)
		{
			varid += std::strchar(astchild.funcname, i);
		} 
	objectsrc += Utilities::tab() + "local " + varid + " = " + astchild.funcname + "( " + objectname + " );" + nl; 
	callast = <<
		~(Utilities::expr_new(astchild.funcname))(guichildobj);
	>>; 
	objectast = <<
		~(objectast); 
		~(callast);
	>>; 
	objectsrc += objectname + "[0] = " + varid + ";" + nl; 
	if (objectxrc["label"] != nil)
		{
			childobj.xrcObj = objectxrc["label"]; 
			childast = Utilities::label(childobj); 
			objectast = <<
				~(objectast); 
				~(Utilities::lvalue_new(objectname))[1] = ~(childast.ast);
			>>; 
			objectsrc += objectname + "[1] = " + childobj.src + ";" + nl;
		}
	else
		{
			objectast = <<
				~(objectast); 
				~(Utilities::lvalue_new(objectname))[1] = "";
			>>; 
			objectsrc += objectname + "[1] = \"\" ;" + nl;
		} 
	if (objectxrc["selected"] != nil)
		{
			childobj.xrcObj = objectxrc["selected"]; 
			childast = Utilities::selected(childobj); 
			objectast = <<
				~(objectast); 
				~(Utilities::lvalue_new(objectname))[2] = ~(( childast.src == "1" ? true : false ));
			>>; 
			objectsrc += objectname + "[2] = " + ( childobj.src == "1" ? "true" : "false" ) + ";" + nl;
		}
	else
		{
			objectast = <<
				~(objectast); 
				~(Utilities::lvalue_new(objectname))[2] = false;
			>>; 
			objectsrc += objectname + "[2] = false;" + nl;
		} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_nbpage_" + nbpageid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "notebookpage"; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(guiobj)
		{
			~(objectast); 
			guiobj["parent"]["addpage"](|~(Utilities::expr_new(objectname))|);
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
function createAuiNoteBook
{
	std::error(::msg + "wxAuiNoteBook");
} 
scrolledwindowid = 0; 
function createScrolledWindow(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "scrolledwindow" + ::scrolledwindowid; 
	objectname = objectxrc["$Attributes"].name; 
	++::scrolledwindowid; 
	local scrolledwindowid = ::scrolledwindowid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "scrolledwindow" + scrolledwindowid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "scrolledwindow"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "scrolledwindow" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::scrolledwindow_construct(guiobj.window, ~("scrolledwindow" + scrolledwindowid));
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "scrolledwindow"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "bg")
										{
											methodname += "backgroundcolour"; 
											child = "colour";
										}
									else
										if (child == "fg")
											{
												methodname += "foregroundcolour"; 
												child = "colour";
											}
										else
											if (child == "pos")
												{
													methodname = "move";
												}
											else
												if (child == "style")
													{
														methodname += "window" + child;
													}
												else
													if (child == "exstyle")
														{
															methodname += "extrastyle";
														}
													else
														if (child == "hidden")
															{
																methodname = "hide";
															}
														else
															if (child == "enabled")
																{
																	methodname = "enable";
																}
															else
																{
																	methodname += std::strlower(child);
																} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createScrolledWindow" + " function in " + "Decoders/Containers.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = <<
		guichildobj.window = ~(Utilities::expr_new(objectname));
	>>; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.window = ~(Utilities::expr_new(objectname)); 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = ~(Utilities::expr_new(objectname)); 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "scrolledwindow" + "_" + ::scrolledwindowid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "scrolledwindow"; 
	tmpast = <<guiobj["parent"]["setwindow"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::expr_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
splitterwindowid = 0; 
function createSplitterWindow(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "splitterwindow" + ::splitterwindowid; 
	objectname = objectxrc["$Attributes"].name; 
	++::splitterwindowid; 
	local splitterwindowid = ::splitterwindowid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "splitterwindow" + splitterwindowid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "splitterwindow"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "splitterwindow" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::scrolledwindow_construct(guiobj.window, ~("splitterwindow" + splitterwindowid));
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "splitterwindow"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "bg")
										{
											methodname += "backgroundcolour"; 
											child = "colour";
										}
									else
										if (child == "fg")
											{
												methodname += "foregroundcolour"; 
												child = "colour";
											}
										else
											if (child == "orientation")
												{
													methodname = "setsplitmode"; 
													child = "splitmode";
												}
											else
												if (child == "sashpos")
													{
														methodname += child + "ition";
													}
												else
													if (child == "gravity")
														{
															methodname += "sash" + child;
														}
													else
														if (child == "minsize")
															{
																methodname = "setminimumpanesize";
															}
														else
															if (child == "pos")
																{
																	methodname = "move";
																}
															else
																if (child == "style")
																	{
																		methodname += "window" + child;
																	}
																else
																	if (child == "exstyle")
																		{
																			methodname += "extrastyle";
																		}
																	else
																		if (child == "hidden")
																			{
																				methodname = "hide";
																			}
																		else
																			if (child == "enabled")
																				{
																					methodname = "enable";
																				}
																			else
																				{
																					methodname += std::strlower(child);
																				} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createSplitterWindow" + " function in " + "Decoders/Containers.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = <<
		guichildobj.window = ~(Utilities::expr_new(objectname));
	>>; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.window = ~(Utilities::expr_new(objectname)); 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = ~(Utilities::expr_new(objectname)); 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "splitterwindow" + "_" + ::splitterwindowid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "splitterwindow"; 
	tmpast = <<guiobj["parent"]["setwindow"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::expr_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
function createListBook
{
	std::error(::msg + "wxListBook");
} 
function createChoiceBook
{
	std::error(::msg + "wxChoiceBook");
}