using #Utilities; 
const nl = "\n"; 
frameid = 0; 
function createFrame(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "frame" + ::frameid; 
	objectname = objectxrc["$Attributes"].name; 
	++::frameid; 
	local frameid = ::frameid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "frame" + frameid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "frame"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "frame" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::frame_construct(guiobj.window, "ID_ANY", ~((Utilities["title"]([
			@xrcObj : objectxrc["title"]
		])).ast));
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "frame"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "bg")
										{
											methodname += "backgroundcolour"; 
											child = "colour";
										}
									else
										if (child == "fg")
											{
												methodname += "foregroundcolour"; 
												child = "colour";
											}
										else
											if (child == "title")
												{
													continue;
												}
											else
												if (child == "centered")
													{
														methodname = "centre";
													}
												else
													if (child == "pos")
														{
															methodname = "move";
														}
													else
														if (child == "style")
															{
																methodname += "window" + child;
															}
														else
															if (child == "exstyle")
																{
																	methodname += "extrastyle";
																}
															else
																if (child == "hidden")
																	{
																		methodname = "hide";
																	}
																else
																	if (child == "enabled")
																		{
																			methodname = "enable";
																		}
																	else
																		{
																			methodname += std::strlower(child);
																		} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									if (child == "font")
										{
											objectast = <<
												~(objectast); 
												~(astchild.ast); 
												local font = ~(Utilities::expr_new(astchild.funcname))(guichildobj); 
												~(Utilities::lvalue_new(objectname))["setfont"](font);
											>>; 
											continue;
										} 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createFrame" + " function in " + "Decoders/Forms.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = <<
		guichildobj.window = ~(Utilities::expr_new(objectname));
	>>; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.window = ~(Utilities::expr_new(objectname)); 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = ~(Utilities::expr_new(objectname)); 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "frame" + "_" + ::frameid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "frame"; 
	tmpast = nil; 
	bodyast = <<
		~(objectast); 
		~(Utilities::expr_new(objectname))["layout"](); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
panelid = 0; 
function createPanel(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "panel" + ::panelid; 
	objectname = objectxrc["$Attributes"].name; 
	++::panelid; 
	local panelid = ::panelid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "panel" + panelid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "panel"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "panel" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::panel_construct(guiobj.window, ~("panel" + panelid));
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "panel"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "bg")
										{
											methodname += "backgroundcolour"; 
											child = "colour";
										}
									else
										if (child == "fg")
											{
												methodname += "foregroundcolour"; 
												child = "colour";
											}
										else
											if (child == "pos")
												{
													methodname = "move";
												}
											else
												if (child == "style")
													{
														methodname += "window" + child;
													}
												else
													if (child == "exstyle")
														{
															methodname += "extrastyle";
														}
													else
														if (child == "hidden")
															{
																methodname = "hide";
															}
														else
															if (child == "enabled")
																{
																	methodname = "enable";
																}
															else
																{
																	methodname += std::strlower(child);
																} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									if (child == "font")
										{
											objectast = <<
												~(objectast); 
												~(astchild.ast); 
												local font = ~(Utilities::expr_new(astchild.funcname))(guichildobj); 
												~(Utilities::lvalue_new(objectname))["setfont"](font);
											>>; 
											continue;
										} 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createPanel" + " function in " + "Decoders/Forms.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = <<
		guichildobj.window = ~(Utilities::expr_new(objectname));
	>>; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.window = ~(Utilities::expr_new(objectname)); 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = ~(Utilities::expr_new(objectname)); 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "panel" + "_" + ::panelid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "panel"; 
	tmpast = <<guiobj["parent"]["setwindow"](~(Utilities::expr_new(objectname)))>>; 
	if (object.parentType == "nbpage")
		tmpast = <<
			guiobj["parent"][0] = ~(Utilities::expr_new(objectname));
		>>; 
	bodyast = <<
		~(objectast); 
		~(Utilities::expr_new(objectname))["layout"](); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::expr_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
dialogid = 0; 
function createDialog(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "dialog" + ::dialogid; 
	objectname = objectxrc["$Attributes"].name; 
	++::dialogid; 
	local dialogid = ::dialogid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "dialog" + dialogid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "dialog"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "dialog" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::dialog_construct(guiobj.window, ~("dialog" + dialogid), ~((Utilities["title"]([
			@xrcObj : objectxrc["title"]
		])).ast));
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "dialog"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "bg")
										{
											methodname += "backgroundcolour"; 
											child = "colour";
										}
									else
										if (child == "fg")
											{
												methodname += "foregroundcolour"; 
												child = "colour";
											}
										else
											if (child == "pos")
												{
													methodname = "move";
												}
											else
												if (child == "style")
													{
														methodname += "window" + child;
													}
												else
													if (child == "exstyle")
														{
															methodname += "extrastyle";
														}
													else
														if (child == "hidden")
															{
																methodname = "hide";
															}
														else
															if (child == "enabled")
																{
																	methodname = "enable";
																}
															else
																{
																	methodname += std::strlower(child);
																} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									if (child == "font")
										{
											objectast = <<
												~(objectast); 
												~(astchild.ast); 
												local font = ~(Utilities::expr_new(astchild.funcname))(guichildobj); 
												~(Utilities::lvalue_new(objectname))["setfont"](font);
											>>; 
											continue;
										} 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createFrame" + " function in " + "Decoders/Forms" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = <<
		guichildobj.window = ~(Utilities::expr_new(objectname));
	>>; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.window = ~(Utilities::expr_new(objectname)); 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = ~(Utilities::expr_new(objectname)); 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "dialog" + "_" + ::dialogid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "dialog"; 
	tmpast = <<guiobj["parent"]["append"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::expr_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
}