using #Utilities; 
const nl = "\n"; 
const msg = "NOT SPPORTED WXWIDGET in delta wxwidgets:" + nl; 
boxsizerid = 0; 
function createBoxSizer(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "boxsizer" + boxsizerid; 
	objectname = objectxrc["$Attributes"].name; 
	++::boxsizerid; 
	local boxsizerid = ::boxsizerid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "boxsizer" + boxsizerid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "boxsizer"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "boxsizer" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::boxsizer_construct(~((Utilities["orient"]([
			@xrcObj : objectxrc["orient"]
		])).ast));
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "boxsizer"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									if (child == "orient")
										{
											continue;
										} 
									local methodname = "set"; 
									methodname += std::strlower(child); 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createBoxSizer" + " function in " + "Decoders/Layouts.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						if (funcname != "sizeritem" and funcname != "spacer")
							{
								std::error("Error: Invalid object child for " + "wxBoxSizer" + " in xrc file! Child name: " + funcname + "!");
							} 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "boxsizer" + "_" + boxsizerid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "boxsizer"; 
	tmpast = <<guiobj["parent"]["setsizer"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	if (object.parentType == "wx_panel")
		{
			bodyast = <<
				~(bodyast); 
				~(Utilities::expr_new(objectname))["fit"](guiobj["parent"]);
			>>;
		} 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
gridsizerid = 0; 
function createGridSizer(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "gridsizer" + gridsizerid; 
	objectname = objectxrc["$Attributes"].name; 
	++::gridsizerid; 
	local gridsizerid = ::gridsizerid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "gridsizer" + gridsizerid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "gridsizer"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "gridsizer" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::gridsizer_construct(~((Utilities["rows"]([
			@xrcObj : objectxrc["rows"]
		])).ast), ~((Utilities["cols"]([
			@xrcObj : objectxrc["cols"]
		])).ast), ~((Utilities["vgap"]([
			@xrcObj : objectxrc["vgap"]
		])).ast), ~((Utilities["hgap"]([
			@xrcObj : objectxrc["hgap"]
		])).ast));
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "gridsizer"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{  }
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						if (funcname != "sizeritem" and funcname != "spacer")
							{
								std::error("Error: Invalid object child for " + "wxGridSizer" + " in xrc file! Child name: " + funcname + "!");
							} 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "gridsizer" + "_" + gridsizerid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "gridsizer"; 
	tmpast = <<guiobj["parent"]["setsizer"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	if (object.parentType == "wx_panel")
		{
			bodyast = <<
				~(bodyast); 
				~(Utilities::expr_new(objectname))["fit"](guiobj["parent"]);
			>>;
		} 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
staticboxsizerid = 0; 
function createStaticBoxSizer(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "staticboxsizer" + staticboxsizerid; 
	objectname = objectxrc["$Attributes"].name; 
	++::staticboxsizerid; 
	local staticboxsizerid = ::staticboxsizerid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "staticboxsizer" + staticboxsizerid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "staticboxsizer"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "staticboxsizer" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::staticboxsizer_construct(~((Utilities["orient"]([
			@xrcObj : objectxrc["orient"]
		])).ast), guiobj.window);
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "staticboxsizer"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									if (child == "orient")
										{
											continue;
										} 
									local methodname = "set"; 
									methodname += std::strlower(child); 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createStaticBoxSizer" + " function in " + "Decoders/Layouts.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						if (funcname != "sizeritem" and funcname != "spacer")
							{
								std::error("Error: Invalid object child for " + "wxStaticBoxSizer" + " in xrc file! Child name: " + funcname + "!");
							} 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "staticboxsizer" + "_" + staticboxsizerid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "staticboxsizer"; 
	tmpast = <<guiobj["parent"]["setsizer"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	if (object.parentType == "wx_panel")
		{
			bodyast = <<
				~(bodyast); 
				~(Utilities::expr_new(objectname))["fit"](guiobj["parent"]);
			>>;
		} 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
gridbagsizerid = 0; 
function createGridBagSizer(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "gridbagsizer" + gridbagsizerid; 
	objectname = objectxrc["$Attributes"].name; 
	++::gridbagsizerid; 
	local gridbagsizerid = ::gridbagsizerid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "gridbagsizer" + gridbagsizerid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "gridbagsizer"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "gridbagsizer" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::gridbagsizer_construct();
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "gridbagsizer"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = nil; 
									if (child == "vgap" or child == "hgap")
										{
											methodname = "set" + child;
										}
									else
										if (child == "growablecols")
											{
												methodname = "addgrowablecol";
											}
										else
											if (child == "growablerows")
												{
													methodname = "addgrowablerow";
												}
											else
												{
													methodname = "set" + std::strlower(child);
												} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createGridBagSizer" + " function in " + "Decoders/Layouts.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						if (funcname != "sizeritem" and funcname != "spacer")
							{
								std::error("Error: Invalid object child for " + "wxGridBagSizer" + " in xrc file! Child name: " + funcname + "!");
							} 
						funcname = "gb" + funcname; 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "gridbagsizer" + "_" + gridbagsizerid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "gridbagsizer"; 
	tmpast = <<
		guiobj["parent"]["setsizer"](~(Utilities::expr_new(objectname)));
	>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	if (object.parentType == "wx_panel")
		{
			bodyast = <<
				~(bodyast); 
				~(Utilities::expr_new(objectname))["fit"](guiobj["parent"]);
			>>;
		} 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
function createFlexGridSizer
{
	std::error(::msg + "wxFlexGridSizer");
} 
function createStdDialogButtonSizer
{
	std::error(::msg + "wxStdDialogButtonSizer");
} 
sizeritemid = 0; 
function createSizerItem(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "sizeritem" + ::sizeritemid; 
	objectname = objectxrc["$Attributes"].name; 
	++::sizeritemid; 
	local sizeritemid = ::sizeritemid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "sizeritem" + sizeritemid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "sizeritem"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "sizeritem" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::sizeritem_construct();
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "sizeritem"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "option")
										{
											methodname += "proportion";
										}
									else
										if (child == "size")
											{
												methodname += "initsize";
											}
										else
											{
												methodname += std::strlower(child);
											} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createSizerItem" + " function in " + "Decoders/Layouts.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "sizeritem" + "_" + ::sizeritemid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "sizeritem"; 
	tmpast = <<guiobj["parent"]["add"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
gbsizeritemid = 0; 
function createGbSizerItem(object)
{
	Utilities::tabincrease(); 
	local tmpast = nil; 
	objectxrc = object.xrcObj; 
	objectid = "gbsizeritem" + ::gbsizeritemid; 
	objectname = objectxrc["$Attributes"].name; 
	++::gbsizeritemid; 
	local gbsizeritemid = ::gbsizeritemid; 
	if (std::isnil(objectname))
		{
			objectname = "g_" + "gbsizeritem" + gbsizeritemid;
		} 
	astmap = object.astMap; 
	funcmap = object.funcMap; 
	local childobj = [
		@funcMap : object.funcMap,
		@astMap : astmap,
		@registerWidgetFuncName : object.registerWidgetFuncName
	]; 
	childobj.parentType = "wx_" + "gbsizeritem"; 
	objectsrc = Utilities::tab() + "local " + objectname + " = wx::" + "gbsizeritem" + "_construct();" + nl; 
	objectast = <<
		local ~(Utilities::id_new(objectname)) = wx::gbsizeritem_construct();
	>>; 
	if (object.registerWidgetFuncName)
		{
			objectast = <<
				~(objectast); 
				GUIWidgets()[~(objectname)] = [
					@data : ~(Utilities::expr_new(objectname)),
					@type : "gbsizeritem"
				];
			>>;
		} 
	foreach (child, std::tabindices(objectxrc))
		{
			if (child != "object")
				{
					if (child == "$Attributes")
						{
							attributes = objectxrc["$Attributes"]; 
							attrindices = std::tabindices(attributes); 
							foreach (attr, attrindices)
								{
									if (attr != "class" and attr != "name")
										{
											local methodname = "set" + attr; 
											astattr = Utilities[attr](attributes); 
											tmpast = <<
												~(Utilities::lvalue_new(objectname))[~(methodname)](~(astattr.ast));
											>>; 
											objectast = <<
												~(objectast); 
												~(tmpast);
											>>; 
											objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astattr.src + ");" + nl;
										}
								}
						}
					else
						{
							try {
									childobj.xrcObj = objectxrc[child]; 
									local methodname = "set"; 
									if (child == "option")
										{
											methodname += "proportion";
										}
									else
										if (child == "size")
											{
												methodname += "initsize";
											}
										else
											if (child == "cellpos")
												{
													methodname += "pos";
												}
											else
												if (child == "cellspan")
													{
														methodname += "span";
													}
												else
													{
														methodname += std::strlower(child);
													} 
									astchild = Utilities[child](childobj); 
									if (child == "flag" and astchild.ast == nil)
										continue; 
									tmpast = <<
										~(Utilities::lvalue_new(objectname))[~(methodname)](~(astchild.ast));
									>>; 
									objectast = <<
										~(objectast); 
										~(tmpast);
									>>; 
									objectsrc += Utilities::tab() + objectname + "." + methodname + " (" + astchild.src + ");" + nl;
								}
							trap e
								{
									std::error("createGbSizerItem" + " function in " + "Decoders/Layouts.dsc" + ": Not Utilities: " + child);
								}
						}
				}
		} 
	astguiwindow = nil; 
	if (Utilities::hasObjectChild(objectxrc) and astguiwindow != nil)
		{
			objectast = <<
				~(objectast); 
				local guichildobj = []; 
				guichildobj.parent = ~(Utilities::expr_new(objectname));
			>>;
		}
	else
		if (Utilities::hasObjectChild(objectxrc))
			{
				objectast = <<
					~(objectast); 
					local guichildobj = []; 
					guichildobj.window = guiobj.window; 
					guichildobj.parent = ~(Utilities::expr_new(objectname));
				>>;
			}
		else
			if (std::isnil(astguiwindow))
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.window = guiobj.window; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				}
			else
				{
					objectast = <<
						~(objectast); 
						local guichildobj = []; 
						guichildobj.parent = ~(Utilities::expr_new(objectname));
					>>;
				} 
	foreach (child, std::tabindices(objectxrc))
		if (child == "object")
			{
				objects = objectxrc["object"]; 
				for (index = 0; index < std::tablength(objects); ++index)
					{
						funcname = objects[index]["$Attributes"]["class"]; 
						childobj.parent = objectname; 
						childobj.xrcObj = objects[index]; 
						astchild = funcmap[funcname](childobj); 
						objectast = <<
							~(objectast); 
							~(astchild.ast);
						>>; 
						objectsrc += astchild.src + nl; 
						local callast = nil; 
						objectsrc += Utilities::tab() + astchild.funcname + "( " + objectname + " );" + nl; 
						callast = <<
							~(Utilities::expr_new(astchild.funcname))(guichildobj);
						>>; 
						objectast = <<
							~(objectast); 
							~(callast);
						>>;
					}
			} 
	Utilities::tabdecrease(); 
	createdfuncname = "create_" + "gbsizeritem" + "_" + ::gbsizeritemid; 
	astmap[objectname] = []; 
	astmap[objectname][0] = createdfuncname; 
	astmap[objectname][1] = "gbsizeritem"; 
	tmpast = <<guiobj["parent"]["add"](~(Utilities::expr_new(objectname)))>>; 
	bodyast = <<
		~(objectast); 
		~(( object.parentType != nil ? tmpast : nil ));
	>>; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(bodyast); 
			return ~(Utilities::expr_new(objectname));
		}>>; 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "() {" + nl + objectsrc + Utilities::tab() + "}"; 
	createdObject = [
		@ast : objectast,
		@astMap : astmap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
} 
spacer = 0; 
function addSpacer(spacerobj)
{
	Utilities::tabincrease(); 
	objectxrc = spacerobj.xrcObj; 
	objectsrc = ""; 
	objectast = nil; 
	createdObject = nil; 
	createdfuncname = "create_spacer" + ::spacer; 
	++::spacer; 
	local proportion = nil; 
	local border = nil; 
	local width = nil; 
	local height = nil; 
	local flag = nil; 
	optionobj = Utilities["option"]([
		@xrcObj : objectxrc["option"]
	]); 
	borderobj = Utilities["border"]([
		@xrcObj : objectxrc["border"]
	]); 
	flagobj = Utilities["flag"]([
		@xrcObj : objectxrc["flag"]
	]); 
	sizeobj = Utilities::GenSizeArgs([
		@xrcObj : objectxrc["size"]
	]); 
	objectsrc = "sizerobj.add (" + sizeobj.src + ", " + optionobj.src + ", " + flagobj.src + ", " + borderobj.src + ");" + nl; 
	objectast = <<
		guiobj["parent"]["add"](~(sizeobj.ast), ~(optionobj.ast), ~(( flagobj.ast ? flagobj.ast : nil )), ~(borderobj.ast));
	>>; 
	Utilities::tabdecrease(); 
	objectsrc = Utilities::tab() + "function " + createdfuncname + "(sizerobj) {" + nl + objectsrc + nl + Utilities::tab() + "}" + nl; 
	objectast = <<function ~(Utilities::id_new(createdfuncname))(~(Utilities::id_new("guiobj")))
		{
			~(objectast);
		}>>; 
	createdObject = [
		@ast : objectast,
		@astMap : spacerobj.astMap,
		@funcname : createdfuncname,
		@src : objectsrc
	]; 
	return createdObject;
}