using #Forms;
using #Layouts;
using #Bars;
using #Common;
using #Containers;
using #Additional;


/*
* Total wxWidgets of wxFormBuilder
*/
function wxObjectMapping () {
	return [
		// Forms
		{ #wxFrame	: Forms::createFrame						},
		{ #wxDialog	: Forms::createDialog						},
		{ #wxPanel	: Forms::createPanel						},
		// Containers
		{ #wxSplitterWindow	: Containers::createSplitterWindow	},
		{ #wxScrolledWindow	: Containers::createScrolledWindow	},
		{ #wxNotebook		: Containers::createNoteBook		},
		{ #notebookpage		: Containers::addNoteBookPage		},
		{ #wxAuiNoteBook	: Containers::createAuiNoteBook		},
		{ #wxListBook		: Containers::createListBook		},
		{ #wxChoiceBook		: Containers::createChoiceBook		},
		// Bars
		{ #wxStatusBar		: Bars::createStatusBar				},
		{ #wxMenuBar		: Bars::createMenuBar				},
		{ #wxMenu			: Bars::createMenu					},
		{ #wxMenuItem		: Bars::createMenuItem				},
		{ #wxToolBar		: Bars::createToolBar				},
		{ #tool				: Bars::addTool						},
		{ #separator		: Bars::addSeparator				},
		// Additionaal
		{ #wxTreeCtrl			: Additional::createTreeCtrl		},
		{ #wxHtmlWindow			: Additional::createHtmlWindow		},
		{ #wxHtmlWindow			: Additional::createHtmlWindow		},
		{ #wxRichTextCtrl		: Additional::createRichTextCtrl	},
		{ #wxCheckListBox		: Additional::createRichTextCtrl	},
		{ #wxGrid				: Additional::createGrid			},
		{ #wxColourPickerCtrl	: Additional::createColourPickerCtrl},
		{ #wxFontPickerCtrl		: Additional::createFontPickerCtrl	},
		{ #wxFilePickerCtrl		: Additional::createFilePickerCtrl	},
		{ #wxDatePickerCtrl		: Additional::createDatePickerCtrl	},
		{ #wxCalendarCtrl		: Additional::createCalendarCtrl	},
		{ #wxScrollBar			: Additional::createScrollBar		},
		{ #wxSpinCtrl			: Additional::createSpinCtrl		},
		{ #wxHyperlinkCtrl		: Additional::createHyperlinkCtrl	},
		{ #wxGenericDirCtrl		: Additional::createGenericDirCtrl	},
		// Sizers
		{ #wxBoxSizer				: Layouts::createBoxSizer				},
		{ #wxStaticBoxSizer			: Layouts::createStaticBoxSizer			},
		{ #wxGridSizer				: Layouts::createGridSizer				},
		{ #wxFlexGridSizer			: Layouts::createFlexGridSizer			},
		{ #wxGridBagSizer			: Layouts::createGridBagSizer			},
		{ #wxStdDialogButtonSizer	: Layouts::createStdDialogButtonSizer	},
		{ #sizeritem				: Layouts::createSizerItem				},
		{ #gbsizeritem				: Layouts::createGbSizerItem			},
		{ #spacer					: Layouts::addSpacer					},
		// Common
		{ #wxButton			: Common::createButton			},
		{ #wxBitmapButton	: Common::createBitmapButton	},
		{ #wxToggleButton	: Common::createToggleButton	},
		{ #wxStaticText		: Common::createStaticText		},
		{ #wxTextCtrl		: Common::createTextCtrl		},
		{ #wxStaticBitmap	: Common::createStaticBitmap	},
		{ #wxComboBox		: Common::createComboBox		},
		{ #wxChoice			: Common::createChoice			},
		{ #wxListBox		: Common::createListBox			},
		{ #wxListCtrl		: Common::createListCtrl		},
		{ #wxCheckBox		: Common::createCheckBox		},
		{ #wxRadioBox		: Common::createRadioBox		},
		{ #wxRadioButton	: Common::createRadioButton		},
		{ #wxStaticLine		: Common::createStaticLine		},
		{ #wxSlider			: Common::createSlider			},
		{ #wxGauge			: Common::createGauge			}
	];
}

