&using #DecoderCore;
&using #GUIASTConverter;
&using #emf2astCore;

dllWX	= std::dllimportdeltalib(wx::DLL);
wx::initallimagehandlers();

app = wx::app_construct();

const nl = "\n";

&DecoderCore::Initialize();

&paintUI = nil;
&classes = nil;
&{
	//load models
	paintUI  = DecoderCore::AstGuiGenerator ("./models/Paint.xrc",  true, nil);
	shapesUI = DecoderCore::AstGuiGenerator ("./models/Shapes.xrc", true, nil);
	classes  = emf2astCore::AstCodeGenerator("./models/Paint.ecore");
	// ui transformations
	GUIASTConverter::insert_child(paintUI, "g_boxsizer13", shapesUI, "g_sizeritem50");
	//
	local initBody = <<
		@selectedTool	= selTool;
		@selectedColor	= selColor;
		@drawingArea	= selColor;
	>>;
	classes.Paint.Core.Initialize.body.push_back(initBody);	
}

!(paintUI);

!(classes);


&DecoderCore::CleanUp();


// main object core of paint
PaintCore = Paint().Core();


//
function InitPaint () {
	//create canvas area of Paint app
	drawingArea = Paint().Canvas().DrawingArea();
	drawingArea.realHeight = 600;
	drawingArea.realWidth  = 800;
	drawingArea.virtualHeight = 600;
	drawingArea.virtualWidth  = 800;
	//init canvas
	drawingArea.bufferData = GUIWidgets()["Canvas"].data;
	drawingArea.bufferData.setsize(drawingArea.realWidth, drawingArea.realHeight);
	//init and pin dc in canvas
	dc = wx::windowdc_construct(drawingArea.bufferData);
	drawingArea.bufferData.dc = dc;

	//create toolbar of Paint app
	toolbar = [];
	toolbar.Shapes  = [];
	toolbar.Shapes.Circle = Paint().Tools().Geometry().Circle();
	toolbar.Shapes.Line   = Paint().Tools().Geometry().Line(); // etc
	toolbar.MainTools = [];
	toolbar.MainTools.Pencil = Paint().Tools().MainToolbar().Pencil();
	toolbar.MainTools.Eraser = Paint().Tools().MainToolbar().Eraser();
	toolbar.MainTools.Alpha  = Paint().Tools().MainToolbar().Alpha();
	toolbar.MainTools.ColorFill = Paint().Tools().MainToolbar().ColorFill();
	toolbar.MainTools.Magnifier = Paint().Tools().MainToolbar().Magnifier();
	//create colour toolbar
	toolColours = Paint().Tools().ColourToolbar().ColourTool();

	// pin objects of paint to core of Paint app
	::PaintCore.Initialize(toolbar, drawingArea, toolColours);
}

function oninitfunc () {
	local guiobj = [];
	::create_gui (guiobj);
	::InitPaint ();
}


wx::app_oninitadd(app, oninitfunc);
wx::app_start(app);


std::dllunimportdeltalib(dllWX);
