using #Utilities;

const nl = "\n";


function local isValidEventInput (event) {
	if ( std::typeof (event) == std::TYPEOF_OBJECT	and
		 std::tablength (event)==3					and
		 std::typeof (event[0])==std::TYPEOF_STRING and
		 std::typeof (event[1])==std::TYPEOF_STRING and
		 std::typeof (event[2])==std::TYPEOF_STRING )
	{
		return true;
	}
	return false;
}


function local addEventNode (name, WidgtetMap, node) {
	
	foreach (index, std::tabindices(WidgtetMap)) {
		if (index == name) {
			local astfunction = WidgtetMap[index];
			local compound = std::ast_get_child(astfunction, 2);
			local stmts = std::ast_get_child(compound, 0);
			// find return stmt in stmts
			ret = nil;
			local visitor = std::astvisitor_new();
			visitor.set_handler("return", function(node, id, entering) { if (entering) ret = node; });
			stmts.accept_preorder(visitor);
			assert (ret!=nil);
			//
			local returnStmt = ret;
			while (std::ast_get_tag(returnStmt)!="Stmt") {
				returnStmt = std::ast_get_parent(returnStmt);
			}
			//
			stmtnode = std::ast_get_child(node, 0);
			stmtnode.remove_from_parent();
			std::ast_insert_before(stmts, returnStmt, stmtnode);
			//
			break;
		}
	}
}

/**
 *
 * Add event in wxwidget name, EVT_TYPE type and function name : funcname (optional)
 * If there is not funcname, function creates one function with name: 
 *	"on" + widgetname + evttype, args frame, event and body
 *  std::error ("function "+ "on"+widgetname+evttype+" not implemented!"+nl);
 *
 **/
function AddEventAstGUI (guiobj, name, type, funcname) {
	local eventfuncsast = nil;
	local args = nil;
	//
	args = <<~(Utilities::expr_new("wx::"+type)), ~(Utilities::expr_new(arguments[3]))>>;
	//
	widgetType = guiobj.typesMap[name];
	local astEvtConnect = nil;
	// 2 kinds of connect function, frame.connect(id, evt_type, funcaddress); name.connect(evt_type, funcaddress);
	if (widgetType != "menuitem" and widgetType != "tool") {
		astEvtConnect = << ~(Utilities::lvalue_new(name)) ["connect"] (~args); >>;
	}
	else {
		astEvtConnect = << ~(Utilities::lvalue_new("guiobj"))["window"]["connect"] (~(Utilities::lvalue_new(name))["getid"](), ~args); >>;
	}
	addEventNode (name, guiobj.astMap, astEvtConnect);
	return eventfuncsast;
}


function AddEventsAstGUI (guiobj, events) {
	foreach (event, events) {
		if (::isValidEventInput(event)) {
			::AddEventAstGUI(guiobj, |event|);
		}
		else {
			std::error ("Invalid type of event in EventInserter::AddEventsAstGUI function!");
		}
	}
}

