using #Data; 
using #Utilities; 
const nl = "\n"; 
converterAstID = 0; 
function local  insertStmtafterStmt(stmt2add, guiastmap, widget)
{
	if (std::isnil(guiastmap[widget]))
		std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
	local node = guiastmap[widget].funcast; 
	local funcname = guiastmap[widget].funcname; 
	for (i = 0; i < 3; ++i)
		node = std::ast_get_parent(node); 
	stmts = std::ast_get_children(node); 
	found = false; 
	local callstmt = nil; 
	foreach (stmt, stmts)
		{
			if (not found)
				{
					local tmpstmt = std::ast_get_child(stmt, 0); 
					if (std::ast_get_tag(tmpstmt) == "FunctionStmt")
						{
							tmpstmt = std::ast_get_child(std::ast_get_child(tmpstmt, 0), 0); 
							if (std::ast_get_attribute(tmpstmt, "name") == funcname)
								{
									found = true;
								}
						}
				}
			else
				{
					callstmt = stmt; 
					break;
				}
		} 
	if (std::isnil(callstmt))
		{
			std::error("Error: in insertStmtafterStmt, not found namenode" + widget + " in astmap.");
		} 
	std::ast_remove_from_parent(stmt2add); 
	std::ast_insert_after(node, callstmt, stmt2add);
} 
function local  insertStmtbeforeStmt(stmt2add, guiastmap, widget)
{
	if (std::isnil(guiastmap[widget]))
		std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
	local node = guiastmap[widget].funcast; 
	local funcname = guiastmap[widget].funcname; 
	for (i = 0; i < 3; ++i)
		node = std::ast_get_parent(node); 
	stmts = std::ast_get_children(node); 
	local funcstmt = nil; 
	foreach (stmt, stmts)
		{
			local tmpstmt = std::ast_get_child(stmt, 0); 
			if (std::ast_get_tag(tmpstmt) == "FunctionStmt")
				{
					tmpstmt = std::ast_get_child(std::ast_get_child(tmpstmt, 0), 0); 
					if (std::ast_get_attribute(tmpstmt, "name") == funcname)
						{
							funcstmt = stmt; 
							break;
						}
				}
		} 
	if (std::isnil(funcstmt))
		{
			std::error("Error: in insertStmtafterStmt, not found namenode" + widget + " in astmap.");
		} 
	std::ast_remove_from_parent(stmt2add); 
	std::ast_insert_before(node, funcstmt, stmt2add);
} 
function local  fixFuncPanelNB(funcast, widget)
{
	local stmts = std::ast_get_child(std::ast_get_child(funcast, 2), 0); 
	local total = std::ast_get_total_children(stmts) - 2; 
	local stmt = std::ast_get_child(stmts, total); 
	local node = stmt; 
	for (i = 0; i < 4; ++i)
		node = std::ast_get_child(node, 0); 
	if (std::ast_get_tag(node) == "AssignOp")
		return; 
	node = <<
		guiobj["parent"][0] = ~(Utilities::expr_new(widget));
	>>; 
	node = std::ast_get_child(node, 0); 
	std::ast_remove_from_parent(node); 
	std::ast_replace(stmts, stmt, node);
} 
function local  fixFuncPanel(funcast, widget)
{
	local stmts = std::ast_get_child(std::ast_get_child(funcast, 2), 0); 
	local total = std::ast_get_total_children(stmts) - 2; 
	local stmt = std::ast_get_child(stmts, total); 
	local node = stmt; 
	for (i = 0; i < 4; ++i)
		node = std::ast_get_child(node, 0); 
	if (std::ast_get_tag(node) != "AssignOp")
		return; 
	node = <<
		guiobj["parent"]["setwindow"](~(Utilities::expr_new(widget)));
	>>; 
	node = std::ast_get_child(node, 0); 
	std::ast_remove_from_parent(node); 
	std::ast_replace(stmts, stmt, node);
} 
function insert_after(ast1, widget1, ast2, widget2)
{
	try {
			local guiastmap1 = Data::AstsMap(ast1.id); 
			local guiastmap2 = Data::AstsMap(ast2.id); 
			if (std::isnil(guiastmap1[widget1]) or std::isnil(guiastmap2[widget2]))
				std::error("Widget name as " + widget2 + " NOT IN GUIAST!"); 
			funcname = guiastmap2[widget2].funcname; 
			funcast = std::ast_copy(guiastmap2[widget2].funcast); 
			if (guiastmap2[widget2].type == "panel")
				if (std::callglobal("getparent_type", ast1, widget1) == "notebookpage")
					fixFuncPanelNB(funcast, widget2);
				else
					fixFuncPanel(funcast, widget2); 
			tmpast = <<
				~(funcast); 
				~(Utilities::expr_new(funcname))(guichildobj);
			>>; 
			local stmt1 = tmpast.get_child(0); 
			local addMap = Data::createAstMap(stmt1); 
			foreach (widget, std::tabindices(addMap))
				guiastmap1[widget] = addMap[widget]; 
			(insertStmtafterStmt)(stmt1, guiastmap1, widget1); 
			(insertStmtafterStmt)(tmpast.get_child(0), guiastmap1, widget1);
		}
	trap e
		{
			std::print("Warning: invalid call of Converter Lib function " + "insert_after" + " !!", nl); 
			std::print("Details:", nl); 
			std::print(e); 
			return "INTRAP";
		} 
	return 1;
} 
function insert_before(ast1, widget1, ast2, widget2)
{
	try {
			local guiastmap1 = Data::AstsMap(ast1.id); 
			local guiastmap2 = Data::AstsMap(ast2.id); 
			if (std::isnil(guiastmap1[widget1]) or std::isnil(guiastmap2[widget2]))
				std::error("Widget name as " + widget2 + " NOT IN GUIAST!"); 
			funcname = guiastmap2[widget2].funcname; 
			funcast = std::ast_copy(guiastmap2[widget2].funcast); 
			if (guiastmap2[widget2].type == "panel")
				if (std::callglobal("getparent_type", ast1, widget1) == "notebookpage")
					fixFuncPanelNB(funcast, widget2);
				else
					fixFuncPanel(funcast, widget2); 
			tmpast = <<
				~(funcast); 
				~(Utilities::expr_new(funcname))(guichildobj);
			>>; 
			local stmt1 = tmpast.get_child(0); 
			local addMap = Data::createAstMap(stmt1); 
			foreach (widget, std::tabindices(addMap))
				guiastmap1[widget] = addMap[widget]; 
			(insertStmtbeforeStmt)(stmt1, guiastmap1, widget1); 
			(insertStmtbeforeStmt)(tmpast.get_child(0), guiastmap1, widget1);
		}
	trap e
		{
			std::print("Warning: invalid call of Converter Lib function " + "insert_before" + " !!", nl); 
			std::print("Details:", nl); 
			std::print(e); 
			return "INTRAP";
		} 
	return 1;
} 
function remove(ast, widget)
{
	try {
			local guiastmap = Data::AstsMap(ast.id); 
			if (std::isnil(guiastmap[widget]))
				std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
			local widgetast = guiastmap[widget].funcast; 
			local funcname = guiastmap[widget].funcname; 
			for (i = 0; i < 3; ++i)
				widgetast = std::ast_get_parent(widgetast); 
			stmts = std::ast_get_children(widgetast); 
			found = false; 
			local callstmt = nil; 
			foreach (stmt, stmts)
				{
					if (not found)
						{
							local tmpstmt = std::ast_get_child(stmt, 0); 
							if (std::ast_get_tag(tmpstmt) == "FunctionStmt")
								{
									tmpstmt = std::ast_get_child(std::ast_get_child(tmpstmt, 0), 0); 
									if (std::ast_get_attribute(tmpstmt, "name") == funcname)
										{
											found = true;
										}
								}
						}
					else
						{
							callstmt = stmt; 
							break;
						}
				} 
			if (std::isnil(callstmt))
				{
					std::error("Error: in insertStmtafterStmt, not found namenode" + widget + " in astmap.");
				} 
			std::ast_remove_from_parent(callstmt); 
			std::ast_remove_from_parent(guiastmap[widget].funcast.get_parent().get_parent()); 
			Data::loadAst(ast);
		}
	trap e
		{
			std::print("Warning: invalid call of Converter Lib function " + "remove" + " !!", nl); 
			std::print("Details:", nl); 
			std::print(e);
		}
} 
function replace(ast1, oldwidget, ast2, newwidget)
{
	local res = ::insert_before(ast1, oldwidget, ast2, newwidget); 
	if (res != "INTRAP")
		::remove(ast1, oldwidget);
} 
function insert_child(ast1, parentwidget, ast2, widget)
{
	try {
			local guiastmap1 = Data::AstsMap(ast1.id); 
			local guiastmap2 = Data::AstsMap(ast2.id); 
			if (std::isnil(guiastmap1[parentwidget]))
				std::error("Widget name as " + parentwidget + " NOT IN GUIAST!"); 
			local parent = guiastmap1[parentwidget].funcast; 
			parent = std::ast_get_child(std::ast_get_child(parent, 2), 0); 
			found = 0; 
			local indexast = nil; 
			local lastindexast = nil; 
			foreach (child, parent.get_children())
				{
					indexast = child; 
					child = child.get_child(0); 
					if (child.get_total_children() == 1 and child.get_tag() == "BasicStmt")
						{
							try {
									for (i = 0; i < 4; ++i)
										child = child.get_child(0); 
									if (std::isnil(child))
										std::error("go to trap");
								}
							trap e
								{
									if (found == 0)
										continue;
									else
										break;
								} 
							if (child.get_tag() == "TableContentDot")
								{
									child = (child.get_child(0)).get_child(0); 
									if (child.get_attribute("name") == "guichildobj")
										{
											lastindexast = indexast; 
											++found; 
											if (found == 2)
												break;
										}
								}
						}
				} 
			if (std::isnil(guiastmap2[widget]))
				std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
			local funcname = guiastmap2[widget].funcname; 
			local funcast = std::ast_copy(guiastmap2[widget].funcast); 
			if (guiastmap2[widget].type == "panel")
				if (std::callglobal("getparent_type", ast1, parentwidget) == "notebookpage")
					fixFuncPanelNB(funcast, widget);
				else
					fixFuncPanel(funcast, widget); 
			local totalstmts = 2; 
			local tmpast = <<
				~(Utilities::expr_new(funcname))(guichildobj); 
				~(funcast);
			>>; 
			if (found == 0)
				{
					lastindexast = indexast; 
					totalstmts = 5; 
					tmpast = <<
						~(tmpast); 
						guichildobj.parent = ~(Utilities::expr_new(parentwidget)); 
						guichildobj.window = guiobj.window; 
						local guichildobj = [];
					>>;
				} 
			local ast2map = nil; 
			for (i = 0; i < totalstmts; ++i)
				{
					if (i == 0)
						ast2map = tmpast.get_child(0); 
					local stmt1 = tmpast.get_child(0); 
					std::ast_remove_from_parent(stmt1); 
					std::ast_insert_after(parent, lastindexast, stmt1);
				} 
			local addMap = Data::createAstMap(ast2map); 
			foreach (widget, std::tabindices(addMap))
				guiastmap1[widget] = addMap[widget];
		}
	trap e
		{
			std::print("Warning: invalid call of Converter Lib function " + "insert_child" + " !!", nl); 
			std::print("Details:", nl); 
			std::print(e);
		}
} 
function getparent(ast, widget)
{
	try {
			guiastmap = Data::AstsMap(ast.id); 
			if (std::isnil(guiastmap[widget]))
				std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
			local node = guiastmap[widget].funcast; 
			for (i = 0; i < 3; ++i)
				node = std::ast_get_parent(node); 
			local node = std::ast_get_parent(std::ast_get_parent(node)); 
			if (node)
				{
					node.id = "c" + ::converterAstID; 
					++::converterAstID; 
					Data::loadAst(node);
				} 
			return node;
		}
	trap e
		{
			return nil;
		}
} 
function getparent_name(ast, widget)
{
	try {
			guiastmap = Data::AstsMap(ast.id); 
			if (std::isnil(guiastmap[widget]))
				std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
			local node = guiastmap[widget].funcast; 
			for (i = 0; i < 3; ++i)
				node = std::ast_get_parent(node); 
			local node = std::ast_get_parent(std::ast_get_parent(node)); 
			return Data::getnamefirststmtbodyfunction(node);
		}
	trap e
		{
			return "Uknown";
		}
} 
function getparent_type(ast, widget)
{
	try {
			guiastmap = Data::AstsMap(ast.id); 
			if (std::isnil(guiastmap[widget]))
				std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
			local node = guiastmap[widget].funcast; 
			for (i = 0; i < 3; ++i)
				node = std::ast_get_parent(node); 
			local node = std::ast_get_parent(std::ast_get_parent(node)); 
			parentType = Data::gettypefirststmtbodyfunction(node); 
			if (parentType)
				return parentType;
			else
				return "notebookpage";
		}
	trap e
		{
			return nil;
		}
} 
function getchild(ast, index)
{
	guiastmap = Data::AstsMap(ast.id); 
	if (std::isnil(guiastmap[index]))
		std::error("Widget name as " + index + " NOT IN GUIAST!"); 
	local node = guiastmap[widget].funcast; 
	local funcname = guiastmap[widget].funcname; 
	for (i = 0; i < 3; ++i)
		node = std::ast_get_parent(node); 
	stmts = std::ast_get_children(node); 
	local count = 0; 
	foreach (stmt, stmts)
		{
			local tmpstmt = std::ast_get_child(stmt, 0); 
			if (std::ast_get_tag(tmpstmt) == "FunctionStmt")
				{
					if (index == count)
						return std::ast_get_child(tmpstmt, 0); 
					++count;
				}
		} 
	return nil;
} 
function getchild_index(ast, widget)
{
	guiastmap = Data::AstsMap(ast.id); 
	if (std::isnil(guiastmap[widget]))
		std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
	return guiastmap[widget];
} 
function getchildren(ast)
{
	guiastmap = Data::AstsMap(ast.id); 
	local node = guiastmap[widget].funcast; 
	local funcname = guiastmap[widget].funcname; 
	for (i = 0; i < 3; ++i)
		node = std::ast_get_parent(node); 
	stmts = std::ast_get_children(node); 
	local childrenList = std::list_new(); 
	foreach (stmt, stmts)
		{
			local tmpstmt = std::ast_get_child(stmt, 0); 
			if (std::ast_get_tag(tmpstmt) == "FunctionStmt")
				{
					local funcChild = std::ast_get_child(tmpstmt, 0); 
					std::list_push_back(childrenList, funcChild);
				}
		} 
	return childrenList;
} 
function getchildren_name(ast)
{
	guiastmap = Data::AstsMap(ast.id); 
	local node = guiastmap[widget].funcast; 
	local funcname = guiastmap[widget].funcname; 
	for (i = 0; i < 3; ++i)
		node = std::ast_get_parent(node); 
	stmts = std::ast_get_children(node); 
	local childrenList = std::list_new(); 
	foreach (stmt, stmts)
		{
			local tmpstmt = std::ast_get_child(stmt, 0); 
			if (std::ast_get_tag(tmpstmt) == "FunctionStmt")
				{
					local funcChild = std::ast_get_child(tmpstmt, 0); 
					foreach (widget, std::tabindices(guiastmap))
						{
							if (guiastmap[widget].funcast == funcChild)
								{
									std::list_push_back(childrenList, widget); 
									break;
								}
						}
				}
		} 
	return childrenList;
} 
function get_total_children(ast)
{
	guiastmap = Data::AstsMap(ast.id); 
	local node = guiastmap[widget].funcast; 
	local funcname = guiastmap[widget].funcname; 
	for (i = 0; i < 3; ++i)
		node = std::ast_get_parent(node); 
	stmts = std::ast_get_children(node); 
	local total = 0; 
	foreach (stmt, stmts)
		{
			local tmpstmt = std::ast_get_child(stmt, 0); 
			if (std::ast_get_tag(tmpstmt) == "FunctionStmt")
				{
					++total;
				}
		} 
	return total;
} 
function get_function(ast, widget)
{
	guiastmap = Data::AstsMap(ast.id); 
	local funcast = ( guiastmap[widget] ? guiastmap[widget].funcast : -1 ); 
	if (funcast != -1)
		{
			funcast.id = "c" + ::converterAstID; 
			++::converterAstID; 
			Data::loadAst(funcast);
		} 
	return funcast;
} 
function get_funcname(ast, widget)
{
	guiastmap = Data::AstsMap(ast.id); 
	return ( guiastmap[widget] ? guiastmap[widget].funcname : -1 );
} 
function add_methodcall(ast, widget, methodName, methodData)
{
	try {
			guiastmap = Data::AstsMap(ast.id); 
			if (std::isnil(guiastmap[widget]))
				std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
			local node = guiastmap[widget].funcast; 
			local funcname = guiastmap[widget].funcname; 
			local stmts = std::ast_get_child(std::ast_get_child(node, 2), 0); 
			index = 0; 
			local child = std::ast_get_child(stmts, 1); 
			local stmt = child; 
			try {
					for (i = 0; i < 8; ++i)
						child = std::ast_get_child(child, 0); 
					if (child.get_attribute("name") == "GUIWidgets")
						index = 1;
				}
			trap e
				{
					index = 2;
				} 
			node = <<
				~(Utilities::expr_new(widget))[~(methodName)](~(methodData));
			>>; 
			node = std::ast_get_child(node, 0); 
			node.remove_from_parent(); 
			if (index == 2)
				std::ast_insert_before(stmts, stmt, node);
			else
				std::ast_insert_after(stmts, stmt, node);
		}
	trap e
		{
			std::print("Warning: invalid call of Converter Lib function " + "add_methodcall" + " !!", nl); 
			std::print("Details:", nl); 
			std::print(e);
		}
} 
function remove_methodcall(ast, widget, methodName)
{
	try {
			guiastmap = Data::AstsMap(ast.id); 
			if (std::isnil(guiastmap[widget]))
				std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
			local node = guiastmap[widget].funcast; 
			local funcname = guiastmap[widget].funcname; 
			local stmts = std::ast_get_child(std::ast_get_child(node, 2), 0); 
			local callstmt = nil; 
			index = 0; 
			foreach (stmt, stmts.get_children())
				{
					local child = std::ast_get_child(stmt, 0); 
					try {
							for (i = 0; i < 5; ++i)
								child = std::ast_get_child(child, 0); 
							child = std::ast_get_child(child, 1); 
							child = std::ast_get_child(child, 0); 
							local items = std::ast_get_attribute(child, "items"); 
							if (items.front() == methodName)
								{
									callstmt = stmt; 
									break;
								}
						}
					trap e
						{
							continue;
						}
				} 
			if (callstmt)
				std::ast_remove_from_parent(callstmt);
			else
				std::print("Warning: Not Found to remove: ", widget, " call method ", methodName);
		}
	trap e
		{
			std::print("Warning: invalid call of Converter Lib function " + "remove_methodcall" + " !!", nl); 
			std::print("Details:", nl); 
			std::print(e);
		}
} 
function edit_methodcall(ast, widget, methodName, methodData)
{
	try {
			guiastmap = Data::AstsMap(ast.id); 
			if (std::isnil(guiastmap[widget]))
				std::error("Widget name as " + widget + " NOT IN GUIAST!"); 
			local node = guiastmap[widget].funcast; 
			local funcname = guiastmap[widget].funcname; 
			local stmts = std::ast_get_child(std::ast_get_child(node, 2), 0); 
			local callstmt = nil; 
			index = 0; 
			foreach (stmt, stmts.get_children())
				{
					local child = std::ast_get_child(stmt, 0); 
					try {
							for (i = 0; i < 5; ++i)
								child = std::ast_get_child(child, 0); 
							child = std::ast_get_child(child, 1); 
							child = std::ast_get_child(child, 0); 
							local items = std::ast_get_attribute(child, "items"); 
							if (items.front() == methodName)
								{
									callstmt = stmt; 
									break;
								}
						}
					trap e
						{
							continue;
						}
				} 
			new = <<
				~(Utilities::expr_new(widget))[~(methodName)](~(methodData));
			>>; 
			new = std::ast_get_child(new, 0); 
			new.remove_from_parent(); 
			if (callstmt)
				std::ast_replace(stmts, callstmt, new);
			else
				std::print("Warning: Not Found to remove: ", widget, " call method ", methodName);
		}
	trap e
		{
			std::print("Warning: invalid call of Converter Lib function " + "edit_methodcall" + " !!", nl); 
			std::print("Details:", nl); 
			std::print(e);
		}
}