using #Utilities;
&using #Utilities;
&using #MetaGen;

const nl  = "\n";
const msg = "NOT SPPORTED WXWIDGET in delta wxwidgets:" + nl;

// Menus

/*
*  wxMenuBar - createMenuBar function decoder
*/

menubarid = 0;

&defsMenuBar = [
	@id				: <<::menubarid>>,
	@funcname		: <<createMenuBar>>,
	@type			: <<"menubar">>,
	@wxconstruct	: <<wx::menubar_construct()>>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<menubarid>>, <<"menubar">>)); >>,
	@fixChildObject	:
		<<
			~(MetaGen::GenerateChildObjectCode (
				<<
				if (funcname != "wxMenu") {
					std::error("Error: Invalid object child for wxMenuBar in xrc file! Child called "+child+" does not supported!");
				}
				>>
			  )
			);
		>>,
	@elseCaseChildCode	: 
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(
				<<
					local methodname = "set";
					methodname += std::strlower (child);
					if (child == "help") methodname += "string";
				>>,
				"createMenuBar",
				"Decoders/Bars.dsc",
				<<
					if (child == "label") {
						astchild.ast = << ~~(objectid), ~~(astchild.ast) >>;
					}
				>>
			  )
			);
		>>,
	@createfuncargs : <<~~( Utilities::id_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"]["setmenubar"]( ~~( Utilities::expr_new(objectname) ) )>>
];

! (MetaGen::GenerateDecoderFunction(defsMenuBar));


/*
*  wxMenu - createMenu function decoder
*/

menuid = 0;

&defsMenu = [
	@id				: <<::menuid>>,
	@funcname		: <<createMenu>>,
	@type			: <<"menu">>,
	@wxconstruct	: <<wx::menu_construct()>>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<menuid>>, <<"menu">>)); >>,
	@fixChildObject	:
		<<
			~(MetaGen::GenerateChildObjectCode (
				<<
				if (funcname != "wxMenu" and funcname != "wxMenuItem" and funcname != "separator") {
					std::error("Error: Invalid object child for wxMenu in xrc file! Child called "+child+" does not supported!");
				}
				>>
				/*<<
					if (funcname == "wxMenu") {
						objectsrc  += nl + Utilities::tab() + objectname +".appendsubmenu ( subcreated );"+nl;
						astarg = << ~~( Utilities::expr_new("subcreated") ) >>;
						tmpast = << ~~(Utilities::expr_new(objectname))["appendsubmenu"] (~~astarg); >>;
						objectast = << ~~objectast; ~~tmpast; >>;
					}
					else
					if (funcname == "wxMenuItem") {
						objectsrc  += nl + Utilities::tab() + objectname +".append ( subcreated );"+nl;
						astarg = << ~~( Utilities::expr_new("subcreated") ) >>;
						tmpast = << ~~(Utilities::expr_new(objectname))["append"] (~~astarg); >>;
						objectast = << ~~objectast; ~~tmpast; >>;
					}
					else
					if (funcname != "separator") {
						std::error("Error: Invalid object child for wxMenu in xrc file! Child called "+child+" does not supported!");
					}
				>>*/ )
				);
		>>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute (
				<<
					local methodname = "set";
					methodname += std::strlower (child);
					if (child == "help") methodname += "string";
				>>,
				"createMenu",
				"Decoders/Bars.dsc",
				<<
					if (child == "label") {
						astchild.ast = << ~~(objectid), ~~(astchild.ast) >>;
					}
				>>
			 )
			);
		>>,
	@createfuncargs : <<~~( Utilities::id_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"][~~(((object.parentType=="wx_menu")?"appendsubmenu":"append"))]( ~~(Utilities::expr_new(objectname)), ~~((Utilities["label"]( [ @xrcObj : objectxrc["label"] ] )).ast) )>>
];

! (MetaGen::GenerateDecoderFunction(defsMenu));


/*
*  wxMenuItem - createMenuItem function decoder
*/

menuitemid = 0;

&defsMenuItem = [
	@id				: <<::menuitemid>>,
	@funcname		: <<createMenuItem>>,
	@type			: <<"menuitem">>,
	@wxconstruct	: <<wx::menuitem_construct(guiobj.parent, wx::ID_ANY)>>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<menuitemid>>, <<"menuitem">>)); >>,
	@fixChildObject		: << ~(MetaGen::GenerateInvalidChildObject("wxMenuItem")); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(
				<<
					local methodname = "set";
					methodname += std::strlower (child);
					if (child == "label") methodname = "settext";
				>>,
				"createMenuItem", "Decoders/Bars.dsc" )
			);
		>>,
	@createfuncargs		: <<~~( Utilities::id_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"]["append"]( ~~( Utilities::expr_new(objectname) ) )>>
];

! (MetaGen::GenerateDecoderFunction(defsMenuItem));



// Tool Bar

/*
*  wxToolBar - createToolBar function decoder
*/

toolbarid = 0;

&defsToolBar = [
	@id				: <<::toolbarid>>,
	@funcname		: <<createToolBar>>,
	@type			: <<"toolbar">>,
	@wxconstruct	: <<wx::toolbar_construct(guiobj.window, ~~("toolbar"+toolbarid))>>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<toolbarid>>, <<"toolbar">>)); >>,
	@fixChildObject	:
		<<
			~(MetaGen::GenerateChildObjectCode (
				<<
				if (funcname != "tool" and funcname != "separator") {
					std::error("Error: Invalid object child for wxToolBar in xrc file! Child called "+child+" does not supported!");
				}
				>> )
			 );
		>>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(
				<<
					local methodname = "set";
					if (child == "style") {
						methodname += "window";
					}
					else
					if (child != "margins") {
						methodname += "tool";
					}
					methodname += std::strlower (child);
				>>,
				"createToolBar", "Decoders/Bars.dsc" )
			);
		>>,
	@createfuncargs : <<~~( Utilities::id_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"]["settoolbar"]( ~~( Utilities::expr_new(objectname) ) )>>,
	@shouldastmethodcalled : <<~~(Utilities::expr_new(objectname))["realize"]()>>
];

! (MetaGen::GenerateDecoderFunction(defsToolBar));


/*
*  wxTool - addTool function decoder
*/

toolid = 0;

&defsTool = [
	@id				: <<::toolid>>,
	@funcname		: <<addTool>>,
	@type			: <<"tool">>,
	@wxconstruct	: <<wx::toolbartoolbase_construct(nil, ~~("tool"+toolid))>>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<toolid>>, <<"tool">>)); >>,
	@fixChildObject	: << ~(MetaGen::GenerateInvalidChildObject("wxTool")); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(
				<<
					local methodname = "set";
					if (child == "bitmap") {
						methodname += "normalbitmap";
					}
					else
					if (child == "tooltip") {
						methodname += "shorthelp";
					}
					else {
						methodname += std::strlower (child);
					}
				>>,
				"addTool", "Decoders/Bars.dsc" )
			);
		>>,
	@createfuncargs : <<~~( Utilities::id_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"]["addtool"]( ~~( Utilities::expr_new(objectname) ) )>>,
	@shoullastmethodcalled : <<~~(Utilities::expr_new(objectname))["realize"]()>>
];

! (MetaGen::GenerateDecoderFunction(defsTool));


// Status Bar

/*
*  wxTool - addTool function decoder
*/

statusbarid = 0;

&defsStatusBar = [
	@id				: <<::statusbarid>>,
	@funcname		: <<createStatusBar>>,
	@type			: <<"statusbar">>,
	@wxconstruct	: <<wx::frame_createstatusbar(guiobj.window)>>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<statusbarid>>, <<"statusbar">>)); >>,
	@fixChildObject	: << ~(MetaGen::GenerateInvalidChildObject("wxStatusBar")); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(
				<<
					local methodname = "set";
					if (child == "style") {
						methodname += "windowstyle";
					}
					else
					if (child == "fields") {
						methodname += "fieldscount";
					}
					else {
						std::error("Error: Invalid");
					}
				>>,
				"createStatusBar", "Decoders/Bars.dsc" )
			);
		>>,
	@createfuncargs : <<~~( Utilities::id_new("guiobj") )>>
];

! (MetaGen::GenerateDecoderFunction(defsStatusBar));


// Separator

separator = 0;

function addSeparator (createobj) {
	Utilities::tabincrease();
	objectsrc = "";
	objectast = nil;
	createdObject = nil;
	createdfuncname = "create_separator";
	methodname = "separator";
	wxname = "";
	if (createobj.parentType == #wx_menu) {
		wxname = "menu";
		methodname = "append" + methodname;
	}
	else if (createobj.parentType == #wx_toolbar) {
		wxname = "toolbar";
		methodname = "add" + methodname;
	}
	else {
		local errormsg = ::msg + "Add separator only for wxMenu and wxToolBar." + nl;
		errormsg += "NOT for " + createobj.parentType + nl;
		std::error( errormsg );
	}
	createdfuncname += wxname + ::separator;
	++::separator;
	objectsrc = Utilities::tab() + wxname +"obj."+ methodname +"();" + nl;
	Utilities::tabdecrease();
	objectsrc = Utilities::tab() + "function " + createdfuncname + "("+wxname+"obj) {" + nl + objectsrc + nl + Utilities::tab() +"}" +nl;
	objectast =
		<<	function ~(Utilities::id_new(createdfuncname)) (guiobj) {
				guiobj.parent [~(methodname)]();
			}
		>>;
	createdObject = [
		@ast	: objectast,
		@astMap	: createobj.astMap,
		@funcname : createdfuncname,
		@src : objectsrc
	];
	return createdObject;
}
