using #Utilities; 
using #MetaGen; 
const nl = "\n"; 
const msg = "NOT SPPORTED WXWIDGET in delta wxwidgets:" + nl; 
defsMenuBar = [
	@id : <<::menubarid>>,
	@funcname : <<createMenuBar>>,
	@type : <<"menubar">>,
	@wxconstruct : <<wx::menubar_construct()>>,
	@objectname : <<
		~(MetaGen::GenerateObjectName(<<menubarid>>, <<"menubar">>));
	>>,
	@fixChildObject : <<
		~(MetaGen::GenerateChildObjectCode(<<
			if (funcname != "wxMenu")
				{
					std::error("Error: Invalid object child for wxMenuBar in xrc file! Child called " + child + " does not supported!");
				}
		>>));
	>>,
	@elseCaseChildCode : <<
		~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(<<
			local methodname = "set"; 
			methodname += std::strlower(child); 
			if (child == "help")
				methodname += "string";
		>>, "createMenuBar", "Decoders/Bars.dsc", <<
			if (child == "label")
				{
					astchild.ast = <<~~(objectid), ~~(astchild.ast)>>;
				}
		>>));
	>>,
	@createfuncargs : <<~~(Utilities::id_new("guiobj"))>>,
	@setobject2parent : <<guiobj["parent"]["setmenubar"](~~(Utilities::expr_new(objectname)))>>
]; 
std::inline(MetaGen::GenerateDecoderFunction(defsMenuBar)); 
defsMenu = [
	@id : <<::menuid>>,
	@funcname : <<createMenu>>,
	@type : <<"menu">>,
	@wxconstruct : <<wx::menu_construct()>>,
	@objectname : <<
		~(MetaGen::GenerateObjectName(<<menuid>>, <<"menu">>));
	>>,
	@fixChildObject : <<
		~(MetaGen::GenerateChildObjectCode(<<
			if (funcname != "wxMenu" and funcname != "wxMenuItem" and funcname != "separator")
				{
					std::error("Error: Invalid object child for wxMenu in xrc file! Child called " + child + " does not supported!");
				}
		>>));
	>>,
	@elseCaseChildCode : <<
		~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(<<
			local methodname = "set"; 
			methodname += std::strlower(child); 
			if (child == "help")
				methodname += "string";
		>>, "createMenu", "Decoders/Bars.dsc", <<
			if (child == "label")
				{
					astchild.ast = <<~~(objectid), ~~(astchild.ast)>>;
				}
		>>));
	>>,
	@createfuncargs : <<~~(Utilities::id_new("guiobj"))>>,
	@setobject2parent : <<guiobj["parent"][~~(( (object.parentType == "wx_menu") ? "appendsubmenu" : "append" ))](~~(Utilities::expr_new(objectname)), ~~((Utilities["label"]([
			@xrcObj : objectxrc["label"]
		])).ast))>>
]; 
std::inline(MetaGen::GenerateDecoderFunction(defsMenu)); 
defsMenuItem = [
	@id : <<::menuitemid>>,
	@funcname : <<createMenuItem>>,
	@type : <<"menuitem">>,
	@wxconstruct : <<wx::menuitem_construct(guiobj.parent, wx::ID_ANY)>>,
	@objectname : <<
		~(MetaGen::GenerateObjectName(<<menuitemid>>, <<"menuitem">>));
	>>,
	@fixChildObject : <<
		~(MetaGen::GenerateInvalidChildObject("wxMenuItem"));
	>>,
	@elseCaseChildCode : <<
		~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(<<
			local methodname = "set"; 
			methodname += std::strlower(child); 
			if (child == "label")
				methodname = "settext";
		>>, "createMenuItem", "Decoders/Bars.dsc"));
	>>,
	@createfuncargs : <<~~(Utilities::id_new("guiobj"))>>,
	@setobject2parent : <<guiobj["parent"]["append"](~~(Utilities::expr_new(objectname)))>>
]; 
std::inline(MetaGen::GenerateDecoderFunction(defsMenuItem)); 
defsToolBar = [
	@id : <<::toolbarid>>,
	@funcname : <<createToolBar>>,
	@type : <<"toolbar">>,
	@wxconstruct : <<wx::toolbar_construct(guiobj.window, ~~("toolbar" + toolbarid))>>,
	@objectname : <<
		~(MetaGen::GenerateObjectName(<<toolbarid>>, <<"toolbar">>));
	>>,
	@fixChildObject : <<
		~(MetaGen::GenerateChildObjectCode(<<
			if (funcname != "tool" and funcname != "separator")
				{
					std::error("Error: Invalid object child for wxToolBar in xrc file! Child called " + child + " does not supported!");
				}
		>>));
	>>,
	@elseCaseChildCode : <<
		~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(<<
			local methodname = "set"; 
			if (child == "style")
				{
					methodname += "window";
				}
			else
				if (child != "margins")
					{
						methodname += "tool";
					} 
			methodname += std::strlower(child);
		>>, "createToolBar", "Decoders/Bars.dsc"));
	>>,
	@createfuncargs : <<~~(Utilities::id_new("guiobj"))>>,
	@setobject2parent : <<guiobj["parent"]["settoolbar"](~~(Utilities::expr_new(objectname)))>>,
	@shouldastmethodcalled : <<~~(Utilities::expr_new(objectname))["realize"]()>>
]; 
std::inline(MetaGen::GenerateDecoderFunction(defsToolBar)); 
defsTool = [
	@id : <<::toolid>>,
	@funcname : <<addTool>>,
	@type : <<"tool">>,
	@wxconstruct : <<wx::toolbartoolbase_construct(nil, ~~("tool" + toolid))>>,
	@objectname : <<
		~(MetaGen::GenerateObjectName(<<toolid>>, <<"tool">>));
	>>,
	@fixChildObject : <<
		~(MetaGen::GenerateInvalidChildObject("wxTool"));
	>>,
	@elseCaseChildCode : <<
		~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(<<
			local methodname = "set"; 
			if (child == "bitmap")
				{
					methodname += "normalbitmap";
				}
			else
				if (child == "tooltip")
					{
						methodname += "shorthelp";
					}
				else
					{
						methodname += std::strlower(child);
					}
		>>, "addTool", "Decoders/Bars.dsc"));
	>>,
	@createfuncargs : <<~~(Utilities::id_new("guiobj"))>>,
	@setobject2parent : <<guiobj["parent"]["addtool"](~~(Utilities::expr_new(objectname)))>>,
	@shoullastmethodcalled : <<~~(Utilities::expr_new(objectname))["realize"]()>>
]; 
std::inline(MetaGen::GenerateDecoderFunction(defsTool)); 
defsStatusBar = [
	@id : <<::statusbarid>>,
	@funcname : <<createStatusBar>>,
	@type : <<"statusbar">>,
	@wxconstruct : <<wx::frame_createstatusbar(guiobj.window)>>,
	@objectname : <<
		~(MetaGen::GenerateObjectName(<<statusbarid>>, <<"statusbar">>));
	>>,
	@fixChildObject : <<
		~(MetaGen::GenerateInvalidChildObject("wxStatusBar"));
	>>,
	@elseCaseChildCode : <<
		~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(<<
			local methodname = "set"; 
			if (child == "style")
				{
					methodname += "windowstyle";
				}
			else
				if (child == "fields")
					{
						methodname += "fieldscount";
					}
				else
					{
						std::error("Error: Invalid");
					}
		>>, "createStatusBar", "Decoders/Bars.dsc"));
	>>,
	@createfuncargs : <<~~(Utilities::id_new("guiobj"))>>
]; 
std::inline(MetaGen::GenerateDecoderFunction(defsStatusBar));