using #Utilities;
&using #Utilities;
&using #MetaGen;

const nl = "\n";


/*
*  wxFrame - createFrame function decoder
*/

frameid = 0;

&defsFrame = [
	@id				: <<::frameid>>,
	@funcname		: <<createFrame>>,
	@type			: <<"frame">>,
	@wxconstruct	: <<wx::frame_construct(guiobj.window, "ID_ANY", ~~((Utilities["title"]( [ @xrcObj : objectxrc["title"] ] )).ast))>>,
	@setguiwindow	: <<guichildobj.window = ~~( Utilities::expr_new(objectname) ); >>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<frameid>>, <<"frame">>)); >>,
	@fixChildObject	:
		<<
			~(MetaGen::GenerateChildObjectCode ());
		>>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute (
				 MetaGen::GenerateWindowMethodname(
					 <<
						// title is set in frame constructor
						if (child == "title") { continue; }
						else
						// bug in form builder centered only value 1 and not wxBOTH / wxHORIZONTAL / wxVERTICAL
						if (child == "centered") {
							methodname = "centre";
						}
						else
							~~code;
					 >>
				 ),
				 "createFrame",
				 "Decoders/Forms.dsc",
				 MetaGen::GenerateFontCase()
			  )
			);
		>>,
	@layout : << ~~( Utilities::expr_new(objectname) ) ["layout"] (); >>,
	@createfuncargs			: <<~~( Utilities::id_new("guiobj") )>>
];

! (MetaGen::GenerateDecoderFunction(defsFrame));


/*
*  wxPanel - createPanel function decoder
*/

panelid = 0;

&defsPanel = [
	@id				: <<::panelid>>,
	@funcname		: <<createPanel>>,
	@type			: <<"panel">>,
	@wxconstruct	: <<wx::panel_construct(guiobj.window, ~~("panel"+panelid) )>>,
	@setguiwindow	: <<guichildobj.window = ~~( Utilities::expr_new(objectname) ); >>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<panelid>>, <<"panel">>)); >>,
	@fixChildObject	: << ~(MetaGen::GenerateChildObjectCode ()); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute (
				 (MetaGen::GenerateWindowMethodname()),
				 "createPanel",
				 "Decoders/Forms.dsc",
				 MetaGen::GenerateFontCase()
			  )
			);
		>>,
	@layout : << ~~( Utilities::expr_new(objectname) ) ["layout"] (); >>,
	@createfuncargs		: << ~~( Utilities::expr_new("guiobj") ) >>,
	@setobject2parent	: << guiobj["parent"]["setwindow"]( ~~( Utilities::expr_new(objectname) ) ) >>,
	@setspecialcasepanel	:
	<<
		if (object.parentType=="nbpage")
			tmpast = <<guiobj["parent"][0]=~~( Utilities::expr_new(objectname) );>>;
	>>
];

! (MetaGen::GenerateDecoderFunction(defsPanel));


/*
*  wxDialog - createDialog function decoder
*/

dialogid = 0;

&defsDialog = [
	@id				: <<::dialogid>>,
	@funcname		: <<createDialog>>,
	@type			: "dialog",
	@wxconstruct	: <<wx::dialog_construct (guiobj.window, ~~("dialog"+dialogid), ~~((Utilities["title"]( [ @xrcObj : objectxrc["title"] ] )).ast))>>,
	@setguiwindow	: <<guichildobj.window = ~~( Utilities::expr_new(objectname) ); >>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<dialogid>>, <<"dialog">>)); >>,
	@fixChildObject	:
		<<
			~(MetaGen::GenerateChildObjectCode ());
		>>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute (
				 (MetaGen::GenerateWindowMethodname()),
				 "createFrame",
				 "Decoders/Forms",
				 MetaGen::GenerateFontCase()
			  )
			);
		>>,
	@createfuncargs : <<~~( Utilities::expr_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"]["append"]( ~~( Utilities::expr_new(objectname) ) )>>
];

! (MetaGen::GenerateDecoderFunction(defsDialog));
