using #Utilities;
&using #MetaGen;

const nl  = "\n";
const msg = "NOT SPPORTED WXWIDGET in delta wxwidgets:" + nl;

// Sizers

/*
*  wxBoxSizer - createBoxSizer function decoder
*/

boxsizerid = 0;

&defsBoxSizer = [
	@id				: <<boxsizerid>>,
	@funcname		: <<createBoxSizer>>,
	@type			: <<"boxsizer">>,
	@wxconstruct	: <<wx::boxsizer_construct( ~~((Utilities["orient"]( [ @xrcObj : objectxrc["orient"] ] )).ast) )>>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<boxsizerid>>, <<"boxsizer">>)); >>,
	@fixChildObject	: << ~(MetaGen::GenerateChildObjectCode ( MetaGen::GenCheckSizersInvalidCase("wxBoxSizer") )); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(
				<<
					// orient set in boxsizer_construct
					if (child == "orient") {
						continue;
					}
					local methodname = "set";
					methodname += std::strlower (child);
				>>,
				"createBoxSizer", "Decoders/Layouts.dsc" )
			);
		>>,
	@createfuncargs 	:
		<< ~~( Utilities::id_new("guiobj") ) >>,
	@setobject2parent	:
		<< guiobj["parent"]["setsizer"]( ~~( Utilities::expr_new(objectname) ) ) >>,
	@fixobj2parent 		:
		<< ~(MetaGen::GenFixObj2Parent ()); >>
];

! (MetaGen::GenerateDecoderFunction(defsBoxSizer));


/*
*  wxGridSizer - createGridSizer function decoder
*/

gridsizerid = 0;

&defsGridSizer = [
	@id				: <<gridsizerid>>,
	@funcname		: <<createGridSizer>>,
	@type			: <<"gridsizer">>,
	@wxconstruct	: 
		<<
			wx::gridsizer_construct(
				~~((Utilities["rows"]( [ @xrcObj : objectxrc["rows"] ] )).ast),
				~~((Utilities["cols"]( [ @xrcObj : objectxrc["cols"] ] )).ast),
				~~((Utilities["vgap"]( [ @xrcObj : objectxrc["vgap"] ] )).ast),
				~~((Utilities["hgap"]( [ @xrcObj : objectxrc["hgap"] ] )).ast)
			)>>,
	//
	@objectname		:
		<< ~(MetaGen::GenerateObjectName (<<gridsizerid>>, <<"gridsizer">>)); >>,
	@fixChildObject	:
		<< ~(MetaGen::GenerateChildObjectCode ( MetaGen::GenCheckSizersInvalidCase("wxGridSizer") ) ); >>,
	@createfuncargs :
		<< ~~( Utilities::id_new("guiobj") ) >>,
	@setobject2parent	:
		<< guiobj["parent"]["setsizer"]( ~~( Utilities::expr_new(objectname) ) ) >>,
	@fixobj2parent :
		<< ~(MetaGen::GenFixObj2Parent ()); >>
];

! (MetaGen::GenerateDecoderFunction(defsGridSizer));


/*
*  wxStaticBoxSizer - createStaticBoxSizer function decoder
*/

staticboxsizerid = 0;

&defsStaticBoxSizer = [
	@id				: <<staticboxsizerid>>,
	@funcname		: <<createStaticBoxSizer>>,
	@type			: <<"staticboxsizer">>,
	@wxconstruct	: <<wx::staticboxsizer_construct( ~~((Utilities["orient"]( [ @xrcObj : objectxrc["orient"] ] )).ast), guiobj.window )>>,
	//
	@objectname		:
		<< ~(MetaGen::GenerateObjectName (<<staticboxsizerid>>, <<"staticboxsizer">>)); >>,
	@fixChildObject	:
		<< ~(MetaGen::GenerateChildObjectCode ( MetaGen::GenCheckSizersInvalidCase("wxStaticBoxSizer")) ); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(
				<<
					// orient set in boxsizer_construct
					if (child == "orient") {
						continue;
					}
					local methodname = "set";
					methodname += std::strlower (child);
				>>,
				"createStaticBoxSizer", "Decoders/Layouts.dsc" )
			);
		>>,
	@createfuncargs :
		<< ~~( Utilities::id_new("guiobj") ) >>,
	@setobject2parent	:
		<< guiobj["parent"]["setsizer"]( ~~( Utilities::expr_new(objectname) ) ) >>,
	@fixobj2parent :
		<< ~(MetaGen::GenFixObj2Parent ()); >>
];

! (MetaGen::GenerateDecoderFunction(defsStaticBoxSizer));


/*
*  wxBoxSizer - createGridBagSizer function decoder
*/

gridbagsizerid = 0;

&defsGridBagSizer = [
	@id				: <<gridbagsizerid>>,
	@funcname		: <<createGridBagSizer>>,
	@type			: <<"gridbagsizer">>,
	@wxconstruct	: <<wx::gridbagsizer_construct()>>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<gridbagsizerid>>, <<"gridbagsizer">>)); >>,
	@fixChildObject	:
		<< ~(MetaGen::GenerateChildObjectCode (
				MetaGen::GenCheckSizersInvalidCase("wxGridBagSizer"),
				<< funcname = "gb" + funcname; >> )
			);
		>>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(
				<<
					// orient set in boxsizer_construct
					local methodname = nil;
					if (child == "vgap" or child == "hgap") {
						methodname = "set" + child;
					}
					else
					if (child == "growablecols") {
						methodname = "addgrowablecol";
					}
					else
					if (child == "growablerows") {
						methodname = "addgrowablerow";
					}
					else {
						methodname = "set" + std::strlower (child);
					}
				>>,
				"createGridBagSizer", "Decoders/Layouts.dsc" )
			);
		>>,
	@createfuncargs	:
		<< ~~( Utilities::id_new("guiobj") ) >>,
	@setobject2parent	:
		<< guiobj["parent"]["setsizer"]( ~~( Utilities::expr_new(objectname) ) ); >>,
	@fixobj2parent		:
		<< ~(MetaGen::GenFixObj2Parent ()); >>
];

! (MetaGen::GenerateDecoderFunction(defsGridBagSizer));



/*
*  wxFlexGridSizer - createFlexGridSizer function decoder
*/

function createFlexGridSizer () { std::error(::msg + "wxFlexGridSizer"); }

/*
*  wxStdDialogButtonSizer - createStdDialogButtonSizer function decoder
*/

function createStdDialogButtonSizer () { std::error(::msg + "wxStdDialogButtonSizer"); }



/*
*  wxSizerItem - createSizerItem function decoder
*/

sizeritemid = 0;

&defsSizerItem = [
	@id				: <<::sizeritemid>>,
	@funcname		: <<createSizerItem>>,
	@type			: <<"sizeritem">>,
	@wxconstruct	: <<wx::sizeritem_construct()>>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<sizeritemid>>, <<"sizeritem">>)); >>,
	@fixChildObject	: << ~(MetaGen::GenerateChildObjectCode ()); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(
				<<
					local methodname = "set";
					if (child == "option") {
						methodname += "proportion";
					}
					else
					if (child == "size") {
						methodname += "initsize";
					}
					else {
						methodname += std::strlower (child);
					}
				>>,
				"createSizerItem", "Decoders/Layouts.dsc"
			  )
			);
		>>,
	@createfuncargs		: <<~~( Utilities::id_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"]["add"]( ~~( Utilities::expr_new(objectname) ) )>>
];

! (MetaGen::GenerateDecoderFunction(defsSizerItem));


/*
*  wxGbSizerItem - createSizerItem function decoder
*/

gbsizeritemid = 0;

&defsGbSizerItem = [
	@id				: <<::gbsizeritemid>>,
	@funcname		: <<createGbSizerItem>>,
	@type			: <<"gbsizeritem">>,
	@wxconstruct	: <<wx::gbsizeritem_construct()>>,
	//
	@objectname		: << ~(MetaGen::GenerateObjectName (<<gbsizeritemid>>, <<"gbsizeritem">>)); >>,
	@fixChildObject	: << ~(MetaGen::GenerateChildObjectCode ()); >>,
	@elseCaseChildCode	:
		<< ~(MetaGen::GenerateElseCaseChildNotObjectOrAttribute(
				<<
					local methodname = "set";
					if (child == "option") {
						methodname += "proportion";
					}
					else
					if (child == "size") {
						methodname += "initsize";
					}
					else
					if (child == "cellpos") {
						methodname += "pos";
					}
					else
					if (child == "cellspan") {
						methodname += "span";
					}
					else {
						methodname += std::strlower (child);
					}
				>>,
				"createGbSizerItem", "Decoders/Layouts.dsc" )
			);
		>>,
	@createfuncargs : <<~~( Utilities::id_new("guiobj") )>>,
	@setobject2parent	: <<guiobj["parent"]["add"]( ~~( Utilities::expr_new(objectname) ) )>>
];

! (MetaGen::GenerateDecoderFunction(defsGbSizerItem));


spacer = 0;

function addSpacer (spacerobj) {
	Utilities::tabincrease();
	objectxrc	= spacerobj.xrcObj;
	objectsrc = "";
	objectast = nil;
	createdObject = nil;
	createdfuncname = "create_spacer" + ::spacer;
	
	++::spacer;
	//childs
	local proportion = nil;
	local border = nil;
	local width = nil;
	local height = nil;
	local flag = nil;
	//
	optionobj	= Utilities[ "option" ] ( [ @xrcObj : objectxrc["option"] ]	);
	borderobj	= Utilities[ "border" ] ( [ @xrcObj : objectxrc["border"] ]	);
	flagobj		= Utilities[ "flag"	  ] ( [ @xrcObj : objectxrc["flag"] ]	);
	sizeobj		= Utilities::GenSizeArgs( [ @xrcObj : objectxrc["size"] ]	);
	//
	objectsrc = "sizerobj.add ("+ sizeobj.src + ", " + optionobj.src + ", " + flagobj.src + ", " + borderobj.src +");"+nl;
	objectast = << guiobj["parent"]["add"] ( ~(sizeobj.ast), ~(optionobj.ast), ~((flagobj.ast?flagobj.ast:nil)), ~(borderobj.ast) ); >>;
	Utilities::tabdecrease();
	//
	objectsrc = Utilities::tab() + "function " + createdfuncname + "(sizerobj) {" + nl + objectsrc + nl + Utilities::tab() +"}" +nl;
	objectast =
		<<	function ~(Utilities::id_new(createdfuncname)) (~(Utilities::id_new("guiobj"))) {
				~(objectast);
			}
		>>;
	createdObject = [
		@ast	: objectast,
		@astMap	: spacerobj.astMap,
		@funcname : createdfuncname,
		@src : objectsrc
	];
	return createdObject;
}

